//code=EUC	tab=4
//
// wizd:	MediaWiz Server daemon.
//
// 		wizd_menu.c
//											$Revision: 1.19 $
//											$Date: 2003/12/21 03:21:10 $
//
//	すべて自己責任でおながいしまつ。
//  このソフトについてVertexLinkに問い合わせないでください。
// ==========================================================================
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <memory.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <unistd.h>
#include <netinet/in.h>
#include <dirent.h>
#include <fcntl.h>


#include "wizd.h"


#define	SORT_FILE_MASK			( 0x000000FF )
#define	SORT_DIR_MASK			( 0x00000F00 )
#define	SORT_DIR_FLAG(_A_)		( ( _A_ & SORT_DIR_MASK ) >> 8 )
#define	SORT_DIR_UP				( 0x00000100 )
#define	SORT_DIR_DOWN			( 0x00000200 )
#define	DEFAULT_SORT_RULE		SORT_NONE






typedef struct {
	unsigned char	name[255];		// 表示用ファイル名
	unsigned char	org_name[255];	// オリジナルファイル名
	mode_t			type;			// 種類
	off_t			size;			// サイズ
	time_t			time;			// 日付
} FILE_INFO_T;



// スキン置換用データ（グローバル）
typedef struct  {

	unsigned char	current_directory_name[FILENAME_MAX];	// 現ディレクトリ 表示用(文字コード調整済み)
	unsigned char	current_directory_link[FILENAME_MAX];	// 現ディレクトリLink用（URIエンコード済み）

	unsigned char	parent_directory_link[FILENAME_MAX];	// 親ディレクトリLink用（URIエンコード済み）



	unsigned char	file_num_str[16];	// 現ディレクトリのファイル数表示用
	unsigned char	now_page_str[16];	// 現在のページ番号表示用
	unsigned char	max_page_str[16];	// 最大ページ番号表示用

	unsigned char	start_file_num_str[16];	// 現在ページの表示開始ファイル番号表示用
	unsigned char	end_file_num_str[16];	// 現在ページの表示開始ファイル番号表示用

	unsigned char	next_page_str[16];	// 次のページ(無ければmax_page)表示用
	unsigned char	prev_page_str[16];	// 一つ前のページ（無ければ 1)表示用

	int		stream_files;	// 再生可能ファイル数


	// 隠しディレクトリ情報
	unsigned char	secret_dir_link_html[512];

    // EUC現ディレクトリ名 (ディレクトリ同文字列削除機能用)
	unsigned char euc_current_dir_name[FILENAME_MAX];


} SKIN_REPLASE_GLOBAL_DATA_T;


// スキン置換用データ。（ファイル）
typedef struct  {
	int				stream_type;			// ストリームファイルか否か
	int				menu_file_type;			// ファイルの種類

	unsigned char	file_name[255];			// ファイル名表示用(文字コード調整済み)
	unsigned char	file_name_no_ext[255];	// 拡張子無しファイル名表示用(文字コード調整済み)
	unsigned char	file_extension[16];	// 拡張子のみ(文字コード調整済み)

	unsigned char	file_uri_link[FILENAME_MAX];	// ファイルへのLink(URIエンコード済み)

	unsigned char	file_timestamp[32];		// タイムスタンプ表示用
	unsigned char	file_timestamp_date[32];	// タイムスタンプ表示用 日付のみ
	unsigned char	file_timestamp_time[32];	// タイムスタンプ表示用 日時のみ

	unsigned char	file_size_string[32];	// ファイルサイズ表示用

	unsigned char	svi_info_data[SVI_INFO_LENGTH];	// SVI ファイル情報
	unsigned char	svi_rec_time_data[32];			// SVI録画時間

	unsigned char	tvid_string[16];	// TVID表示用
	unsigned char	vod_string[32];		// vod="0" or vod="playlist"  必要に応じて付く

	unsigned char	image_width[16];	// 画像データ 横幅
	unsigned char	image_height[16];	// 画像データ 高さ


	// MP3 ID3v1 タグ情報
	unsigned char	mp3_id3v1_flag;			// MP3 タグ 存在フラグ
	unsigned char	mp3_id3v1_title[32];	// MP3 曲名
	unsigned char	mp3_id3v1_album[32];	// MP3 アルバム名
	unsigned char	mp3_id3v1_artist[32];	// MP3 アーティスト
	unsigned char	mp3_id3v1_year[8];		// MP3 制作年度
	unsigned char	mp3_id3v1_comment[32];	// MP3 コメント

	unsigned char	mp3_id3v1_title_info[32*3];			// MP3 曲名[アルバム名/アーティスト] まとめて表示
	unsigned char	mp3_id3v1_title_info_limited[32*3];	// MP3 曲名[アルバム名/アーティスト] まとめて表示(字数制限あり)



} SKIN_REPLASE_LINE_DATA_T;



// ImageViewer 置換用データ
typedef struct  {

	unsigned char	current_uri_name[FILENAME_MAX];	// 現URI 表示用(文字コード調整済み)
	unsigned char	current_uri_link[FILENAME_MAX];	// 現URI Link用（URIエンコード済み）

	unsigned char	parent_directory_link[FILENAME_MAX];	// 親ディレクトリLink用（URIエンコード済み）

	unsigned char	now_page_str[16];	// 現在のページ番号表示用

	unsigned char	file_timestamp[32];			// タイムスタンプ表示用(日時)
	unsigned char	file_timestamp_date[32];	// タイムスタンプ表示用(日付のみ)
	unsigned char	file_timestamp_time[32];		// タイムスタンプ表示用(時刻のみ)
	unsigned char	file_size_string[32];		// ファイルサイズ表示用

	unsigned char	image_width[16];			// 画像データ 横幅
	unsigned char	image_height[16];			// 画像データ 高さ

	unsigned char	image_viewer_width[16];		// 画像データ 表示横幅
	unsigned char	image_viewer_height[16];	// 画像データ 表示高さ

	unsigned char	image_viewer_mode[16];		// 表示モード

} SKIN_REPLASE_IMAGE_VIEWER_DATA_T;


#define		FILEMENU_BUF_SIZE	(1024*16)


static int count_file_num(unsigned char *path);
static int directory_stat(unsigned char *path, FILE_INFO_T *file_info_p, int file_num);

static int file_ignoral_check(unsigned char *name, unsigned char *path);
static int directory_same_check_svi_name(unsigned char *name);

static void http_filemenu_send(int accept_socket, unsigned char *filemenu_data);

//static void create_system_filemenu(HTTP_RECV_INFO *http_recv_info_p, FILE_INFO_T *file_info_p, int file_num, unsigned char *send_filemenu_buf, int buf_size);
static void create_skin_filemenu(HTTP_RECV_INFO *http_recv_info_p, FILE_INFO_T *file_info_p, int file_num, unsigned char *send_filemenu_buf, int buf_size);
static void create_all_play_list(HTTP_RECV_INFO *http_recv_info_p, FILE_INFO_T *file_info_p, int file_num, unsigned char *send_filemenu_buf, int buf_size);

static unsigned char *skin_file_read(unsigned char *read_filename, int *malloc_size );


static void replase_skin_grobal_data(unsigned char *menu_work_p, int menu_work_buf_size, SKIN_REPLASE_GLOBAL_DATA_T *skin_rep_data_global_p);
static void replase_skin_line_data(unsigned char *menu_work_p, int menu_work_buf_size, SKIN_REPLASE_LINE_DATA_T *skin_rep_data_line_p);

static void  mp3_id3v1_tag_read(unsigned char *mp3_filename, SKIN_REPLASE_LINE_DATA_T *skin_rep_data_line_p );
static void playlist_filename_adjustment(unsigned char *src_name, unsigned char *dist_name, int dist_size, int input_code );

static int file_read_line( int fd, unsigned char *line_buf, int line_buf_size);


static void 	file_info_sort( FILE_INFO_T *p, int num, unsigned long type );
static int 		_file_info_dir_sort( const void *in_a, const void *in_b, int order );
static int	 	_file_info_dir_sort_order_up( const void *in_a, const void *in_b );
static int 		_file_info_dir_sort_order_down( const void *in_a, const void *in_b );
static int		_file_info_name_sort( const void *in_a, const void *in_b, int order );
static int 		_file_info_name_sort_order_up( const void *in_a, const void *in_b );
static int 		_file_info_name_sort_order_down( const void *in_a, const void *in_b );
static int 		_file_info_size_sort( const void *in_a, const void *in_b, int order );
static int 		_file_info_size_sort_order_up( const void *in_a, const void *in_b );
static int 		_file_info_size_sort_order_down( const void *in_a, const void *in_b );
static int 		_file_info_time_sort( const void *in_a, const void *in_b, int order );
static int 		_file_info_time_sort_order_up( const void *in_a, const void *in_b );
static int 		_file_info_time_sort_order_down( const void *in_a, const void *in_b );


// ファイルソート用関数配列
static void * file_sort_api[] = {
	NULL,
	_file_info_name_sort_order_up,
	_file_info_name_sort_order_down,
	_file_info_time_sort_order_up,
	_file_info_time_sort_order_down,
	_file_info_size_sort_order_up,
	_file_info_size_sort_order_down,
};


// ディレクトリソート用関数配列
static void * dir_sort_api[] = {
	NULL,
	_file_info_dir_sort_order_up,
	_file_info_dir_sort_order_down
};




// **************************************************************************
// ファイルリストを生成して返信
// **************************************************************************
void http_menu(int accept_socket, HTTP_RECV_INFO *http_recv_info_p)
{
	unsigned char	*filemenu_buf_malloc_p;

	int				file_num;	// DIR内のファイル数
	unsigned char	*file_info_malloc_p;
	FILE_INFO_T		*file_info_p;


	// recv_uri の最後が'/'でなかったら、'/'を追加
	if (( strlen(http_recv_info_p->recv_uri) > 0 ) &&
		( http_recv_info_p->recv_uri[strlen(http_recv_info_p->recv_uri)-1] != '/' ))
	{
		strncat(http_recv_info_p->recv_uri, "/", sizeof(http_recv_info_p->recv_uri) - strlen(http_recv_info_p->recv_uri) );
	}


	//  http_recv_info_p->send_filename の最後が'/'でなかったら、'/'を追加
	if (( strlen(http_recv_info_p->send_filename) > 0 ) &&
		( http_recv_info_p->send_filename[strlen(http_recv_info_p->send_filename)-1] != '/' ))
	{
		strncat(http_recv_info_p->send_filename, "/", sizeof(http_recv_info_p->send_filename) - strlen(http_recv_info_p->send_filename) );
	}


	// ==================================
	// ディレクトリ情報をＧＥＴ
	// ==================================

	// recv_uri ディレクトリのファイル数を数える。
	file_num = count_file_num( http_recv_info_p->send_filename );
	debug_log_output("file_num = %d", file_num);
	if ( file_num < 0 )
	{
		return;
	}


	// 必要な数だけ、ファイル情報保存エリアをmalloc()
	file_info_malloc_p = malloc( sizeof(FILE_INFO_T)*file_num );
	if ( file_info_malloc_p == NULL )
	{
		debug_log_output("malloc() error");
		return;
	}


	memset(file_info_malloc_p, 0, sizeof(FILE_INFO_T)*file_num);
	file_info_p = (FILE_INFO_T *)file_info_malloc_p;



	// -----------------------------------------------------
	// ファイル情報保存エリアに、ディレクトリ情報を読み込む。
	// -----------------------------------------------------
	file_num = directory_stat(http_recv_info_p->send_filename, file_info_p, file_num);
	debug_log_output("file_num = %d", file_num);


	// デバッグ。file_info_malloc_p 表示
	//for ( i=0; i<file_num; i++ )
	//{
	//	debug_log_output("file_info[%d] name='%s'", i, file_info_p[i].name );
	//	debug_log_output("file_info[%d] size='%d'", i, file_info_p[i].size );
	//	debug_log_output("file_info[%d] time='%d'", i, file_info_p[i].time );
	//}


	// ---------------------------------------------------
	// sort=でソートが指示されているか確認
	// 指示されていたら、それでglobal_paramを上書き
	// ---------------------------------------------------
	if ( strlen(http_recv_info_p->sort) > 0 )
	{
		if (strcasecmp(http_recv_info_p->sort ,"none") == 0 )
			global_param.sort_rule = SORT_NONE;
		else if (strcasecmp(http_recv_info_p->sort ,"name_up") == 0 )
			global_param.sort_rule = SORT_NAME_UP;
		else if (strcasecmp(http_recv_info_p->sort ,"name_down") == 0 )
			global_param.sort_rule = SORT_NAME_DOWN;
		else if (strcasecmp(http_recv_info_p->sort ,"time_up") == 0 )
			global_param.sort_rule = SORT_TIME_UP;
		else if (strcasecmp(http_recv_info_p->sort ,"time_down") == 0 )
			global_param.sort_rule = SORT_TIME_DOWN;
		else if (strcasecmp(http_recv_info_p->sort ,"size_up") == 0 )
			global_param.sort_rule = SORT_SIZE_UP;
		else if (strcasecmp(http_recv_info_p->sort ,"size_down") == 0 )
			global_param.sort_rule = SORT_SIZE_DOWN;
	}

	// 必要ならば、ソート実行
	if ( global_param.sort_rule != SORT_NONE )
	{
		file_info_sort( file_info_p, file_num,  global_param.sort_rule | SORT_DIR_UP  );
	}


	// =============================
	// 返信データ生成領域をmalloc
	// =============================
	filemenu_buf_malloc_p = malloc( FILEMENU_BUF_SIZE );
	if (filemenu_buf_malloc_p == NULL)
	{
		debug_log_output("malloc() error");
		return;
	}

	// -------------------------------------------
	// 自動再生
	// -------------------------------------------
	if ( strcasecmp(http_recv_info_p->action, "allplay") == 0 )
	{
		create_all_play_list(http_recv_info_p, file_info_p, file_num, filemenu_buf_malloc_p, FILEMENU_BUF_SIZE );
		debug_log_output("AllPlay List Create End!!! ");
	}
	// -------------------------------------------
	// ファイルメニュー生成
	// 外部スキンと組み込みスキンで分岐
	//	 （組み込みスキン、さっさと作れと小一時間……)
	// -------------------------------------------
	else
	{
	//	if ( global_param.flag_use_skin == TRUE )
	//	{
			create_skin_filemenu(http_recv_info_p, file_info_p, file_num, filemenu_buf_malloc_p, FILEMENU_BUF_SIZE );
	//	}
	//	else
	//	{
	//		create_system_filemenu(http_recv_info_p, file_info_p, file_num, filemenu_buf_malloc_p, FILEMENU_BUF_SIZE );
	//	}
		debug_log_output("Menu Create End!!! ");
	}

	debug_log_output("send_filemenu_size=%d", strlen(filemenu_buf_malloc_p)) ;



	// =================
	// 返信実行
	// =================
	http_filemenu_send( accept_socket, filemenu_buf_malloc_p );


	free(filemenu_buf_malloc_p);
	free(file_info_malloc_p);

	return;
}





// ****************************************************************************************
// メニュー生成用のdefineいろいろ。
// ****************************************************************************************



#define		SKIN_MENU_CONF						"wizd_skin.conf"

#define		SKIN_MENU_HEAD_HTML					"head.html"
#define		SKIN_MENU_LINE_MOVIE_FILE_HTML		"line_movie.html"
#define		SKIN_MENU_LINE_MUSIC_FILE_HTML		"line_music.html"
#define		SKIN_MENU_LINE_IMAGE_FILE_HTML		"line_image.html"
#define		SKIN_MENU_LINE_DOCUMENT_FILE_HTML	"line_document.html"
#define		SKIN_MENU_LINE_UNKNOWN_FILE_HTML	"line_unknown.html"
#define		SKIN_MENU_LINE_SVI_FILE_HTML		"line_svi_file.html"
#define		SKIN_MENU_LINE_DIR_HTML				"line_dir.html"
#define		SKIN_MENU_TAIL_HTML					"tail.html"


#define		SKIN_KEYWORD_SERVER_NAME		"<!--WIZD_INSERT_SERVER_NAME-->"		// サーバ名＆バージョン。表示用
#define		SKIN_KEYWORD_CURRENT_PATH		"<!--WIZD_INSERT_CURRENT_PATH-->"		// 現PATH。表示用

#define		SKIN_KEYWORKD_PARLENT_DIR_LINK	"<!--WIZD_INSERT_PARENT_DIR_LINK-->"	// 親ディレクトリ。LINK用 URIエンコード済み
#define		SKIN_KEYWORKD_PARLENT_DIR_NAME	"<!--WIZD_INSERT_PARENT_DIR_NANE-->"	// 親ディレクトリ。表示用

#define		SKIN_KEYWORD_CURRENT_PATH_LINK	"<!--WIZD_INSERT_CURRENT_PATH_LINK-->"	// 現PATH。LINK用。URIエンコード済み


#define		SKIN_KEYWORD_CURRENT_PAGE		"<!--WIZD_INSERT_CURRENT_PAGE-->"		// 現在のページ
#define		SKIN_KEYWORD_MAX_PAGE			"<!--WIZD_INSERT_MAX_PAGE-->"			// 全ページ数
#define		SKIN_KEYWORD_NEXT_PAGE			"<!--WIZD_INSERT_NEXT_PAGE-->"			// 次のページ
#define		SKIN_KEYWORD_PREV_PAGE			"<!--WIZD_INSERT_PREV_PAGE-->"			// 前のページ
#define		SKIN_KEYWORD_FILE_NUM			"<!--WIZD_INSERT_FILE_NUM-->"			// ディレクトリ存在ファイル数
#define		SKIN_KEYWORD_START_FILE_NUM		"<!--WIZD_INSERT_START_FILE_NUM-->"		// 次のページ
#define		SKIN_KEYWORD_END_FILE_NUM		"<!--WIZD_INSERT_END_FILE_NUM-->"		// 前のページ

#define		SKIN_KEYWORD_LINE_FILE_NAME			"<!--WIZD_INSERT_LINE_FILE_NAME-->"			// ファイル名 表示用
#define		SKIN_KEYWORD_LINE_FILE_NAME_NO_EXT	"<!--WIZD_INSERT_LINE_FILE_NAME_NO_EXT-->"	// ファイル名(拡張子無し) 表示用
#define		SKIN_KEYWORD_LINE_FILE_EXT			"<!--WIZD_INSERT_LINE_FILE_EXT-->"			// ファイル拡張子 表示用
#define		SKIN_KEYWORD_LINE_FILE_LINK			"<!--WIZD_INSERT_LINE_FILE_LINK-->"			// ファイル名 リンク用 URIエンコード

#define		SKIN_KEYWORD_LINE_TIMESTAMP		"<!--WIZD_INSERT_LINE_TIMESTAMP-->"		// タイムスタンプ 日時(YYYY/MM/DD HH:MM) 表示用

#define		SKIN_KEYWORD_LINE_FILE_DATE		"<!--WIZD_INSERT_LINE_FILE_DATE-->"		// タイムスタンプ 日付のみ(YYYY/MM/DD) 表示用
#define		SKIN_KEYWORD_LINE_FILE_TIME		"<!--WIZD_INSERT_LINE_FILE_TIME-->"		// タイムスタンプ 時刻のみ(HH:MM) 表示用



#define		SKIN_KEYWORD_LINE_TVID			"<!--WIZD_INSERT_LINE_TVID-->"			// TVID

#define		SKIN_KEYWORD_LINE_FILE_VOD		"<!--WIZD_INSERT_LINE_FILE_VOD-->"		// vod="0"  必要に応じて付く。
#define		SKIN_KEYWORD_LINE_FILE_SIZE		"<!--WIZD_INSERT_LINE_FILE_SIZE-->"		// ファイルサイズ 表示用

#define		SKIN_KEYWORD_LINE_SVI_INFO		"<!--WIZD_INSERT_LINE_SVI_INFO-->"		// SVIファイルから読んだ情報 表示用
#define		SKIN_KEYWORD_LINE_SVI_REC_TIME	"<!--WIZD_INSERT_LINE_SVI_REC_TIME-->"	// SVIファイルの録画時間

#define		SKIN_KEYWORD_LINE_IMAGE_WIDTH	"<!--WIZD_INSERT_LINE_IMAGE_WIDTH-->"	// 画像の横幅
#define		SKIN_KEYWORD_LINE_IMAGE_HEIGHT	"<!--WIZD_INSERT_LINE_IMAGE_HEIGHT-->"	// 画像の高さ

#define		SKIN_KEYWORD_SECRET_DIR_LINK	"<!--WIZD_INSERT_SECRET_DIR_LINK-->"	// 隠しディレクトリ


#define		SKIN_KEYWORD_LINE_MP3TAG_TITLE		"<!--WIZD_INSERT_LINE_MP3TAG_TITLE-->"		// MP3タグ タイトル
#define		SKIN_KEYWORD_LINE_MP3TAG_ALBUM		"<!--WIZD_INSERT_LINE_MP3TAG_ALBUM-->"		// MP3タグ アルバム名
#define		SKIN_KEYWORD_LINE_MP3TAG_ARTIST		"<!--WIZD_INSERT_LINE_MP3TAG_ARTIST-->"		// MP3タグ アーティスト
#define		SKIN_KEYWORD_LINE_MP3TAG_YEAR		"<!--WIZD_INSERT_LINE_MP3TAG_YEAR-->"		// MP3タグ 制作年度
#define		SKIN_KEYWORD_LINE_MP3TAG_COMMENT	"<!--WIZD_INSERT_LINE_MP3TAG_COMMENT-->"	// MP3タグ コメント

#define		SKIN_KEYWORD_LINE_MP3TAG_TITLE_INFO	"<!--WIZD_INSERT_LINE_MP3TAG_TITLE_INFO-->"	// MP3タグ タイトル[アルバム名/アーティスト] 表示(menu_filename_length_maxによる制限も効く)


// 以下のキーワードで挟まれたエリアは、条件一致したときに削除される。

// ルートディレクトリの場合 (HEAD/TAILのみ)
#define		SKIN_KEYWORD_DEL_IS_ROOTDIR				"<!--WIZD_DELETE_IS_ROOTDIR-->"
#define		SKIN_KEYWORD_DEL_IS_ROOTDIR_E			"<!--/WIZD_DELETE_IS_ROOTDIR-->"

// 前ページが存在しない場合 (HEAD/TAILのみ)
#define		SKIN_KEYWORD_DEL_IS_NO_PAGE_PREV		"<!--WIZD_DELETE_IS_NO_PAGE_PREV-->"
#define		SKIN_KEYWORD_DEL_IS_NO_PAGE_PREV_E		"<!--/WIZD_DELETE_IS_NO_PAGE_PREV-->"

// 次ページが存在しない場合 (HEAD/TAILのみ)
#define		SKIN_KEYWORD_DEL_IS_NO_PAGE_NEXT		"<!--WIZD_DELETE_IS_NO_PAGE_NEXT-->"
#define		SKIN_KEYWORD_DEL_IS_NO_PAGE_NEXT_E		"<!--/WIZD_DELETE_IS_NO_PAGE_NEXT-->"

// 再生可能ファイルが存在しない場合 (HEAD/TAILのみ)
#define		SKIN_KEYWORD_DEL_IS_NO_STREAM_FILES		"<!--WIZD_DELETE_IS_NO_STREAM_FILES-->"
#define		SKIN_KEYWORD_DEL_IS_NO_STREAM_FILES_E	"<!--/WIZD_DELETE_IS_NO_STREAM_FILES-->"


// MP3タグが存在しないとき (LINEのみ)
#define		SKIN_KEYWORD_DEL_IS_NO_MP3_TAGS			"<!--WIZD_DELETE_IS_NO_MP3_TAGS-->"
#define		SKIN_KEYWORD_DEL_IS_NO_MP3_TAGS_E		"<!--/WIZD_DELETE_IS_NO_MP3_TAGS-->"

// MP3タグが存在するとき (LINEのみ)
#define		SKIN_KEYWORD_DEL_IS_HAVE_MP3_TAGS		"<!--WIZD_DELETE_IS_HAVE_MP3_TAGS-->"
#define		SKIN_KEYWORD_DEL_IS_HAVE_MP3_TAGS_E		"<!--/WIZD_DELETE_IS_HAVE_MP3_TAGS-->"


// **************************************************************************
// スキンを使用したファイルメニューを生成
// **************************************************************************
static void create_skin_filemenu(HTTP_RECV_INFO *http_recv_info_p, FILE_INFO_T *file_info_p, int file_num, unsigned char *send_filemenu_buf, int buf_size)
{

	unsigned char	*menu_head_skin_p;
	int				menu_head_skin_malloc_size;

	unsigned char	*menu_tail_skin_p;
	int 			menu_tail_skin_malloc_size;

	unsigned char	*menu_line_movie_skin_p;
	int				menu_line_movie_skin_malloc_size;

	unsigned char	*menu_line_music_skin_p;
	int				menu_line_music_skin_malloc_size;

	unsigned char	*menu_line_image_skin_p;
	int				menu_line_image_skin_malloc_size;

	unsigned char	*menu_line_document_skin_p;
	int				menu_line_document_skin_malloc_size;

	unsigned char	*menu_line_unknown_skin_p;
	int				menu_line_unknown_skin_malloc_size;

	unsigned char	*menu_line_svi_skin_p;
	int				menu_line_svi_skin_malloc_size;

	unsigned char	*menu_line_dir_skin_p;
	int				menu_line_dir_skin_malloc_size;


	unsigned char	*menu_work_p;

	unsigned char	skin_path[FILENAME_MAX];
	unsigned char	read_filename[FILENAME_MAX];

	int		i, j;


	unsigned char	work_filename[FILENAME_MAX];

	unsigned char	work_data[FILENAME_MAX];
	unsigned char	work_data2[FILENAME_MAX];

	int		now_page;		// 現在のページ番号
	int		max_page;		// 最大ページ番号
	int		now_page_line;	// 現在のページの表示行数
	int		start_file_num;	// 現在ページの表示開始ファイル番号
	int		end_file_num;	// 現在ページの表示終了ファイル番号

	int		next_page;		// 次のページ(無ければmax_page)
	int		prev_page;		// 一つ前のページ（無ければ 1)


	SKIN_REPLASE_GLOBAL_DATA_T	*skin_rep_data_global_p;
	SKIN_REPLASE_LINE_DATA_T	*skin_rep_data_line_p;

	int skin_rep_line_malloc_size;

	unsigned int	rec_time;
	int	count;

	unsigned int	image_width, image_height;

	struct	stat	dir_stat;
	int				result;

	// ==========================================
	// SKINコンフィグファイル読み込む
	// ==========================================

	// ----------------------------------------------
	// スキンのあるファイルパス生成（フルパス)
	// ----------------------------------------------
	strncpy(skin_path, global_param.skin_root, sizeof(skin_path) ); // スキン置き場
	if ( skin_path[ strlen(skin_path)-1 ] != '/' )// 最後が'/'じゃなかったら、'/'を追加
	{
		strncat(skin_path, "/", sizeof(skin_path) -strlen(skin_path) );
	}

	strncat(skin_path, global_param.skin_name, sizeof(skin_path) - strlen(skin_path) ); // スキン名（ディレクトリ）
	if ( skin_path[ strlen(skin_path)-1 ] != '/' ) // 最後が'/'じゃなかったら、'/'を追加
	{
		strncat(skin_path, "/", sizeof(skin_path) - strlen(skin_path) );
	}


	// ----------------------------------------------
	// SKINコンフィグファイルのフルパス生成
	// ----------------------------------------------
	strncpy(read_filename, skin_path, sizeof(read_filename) );
	strncat(read_filename, SKIN_MENU_CONF, sizeof(read_filename)- strlen(read_filename) );
	debug_log_output("skin: read_config_filename='%s'", read_filename);

	// ----------------------------------------------
	// SKIN コンフィグファイル 読み込み実行
	// ----------------------------------------------
	skin_config_file_read(read_filename);



	// ==========================================
	// HTML生成準備 各種計算等
	// ==========================================

	// ディレクトリ存在ファイル数
	debug_log_output("file_num = %d", file_num);

	// 最大ページ数計算
	if ( file_num == 0 )
	{
		max_page = 1;
	}
	else if ( (file_num % global_param.page_line_max) == 0 )
	{
		max_page = (file_num / global_param.page_line_max);
	}
	else
	{
		max_page = (file_num / global_param.page_line_max) + 1;
	}
	debug_log_output("max_page = %d", max_page);

	// 現在表示ページ番号 計算。
	if ( (http_recv_info_p->page <= 1 ) || (max_page < http_recv_info_p->page ) )
		now_page = 1;
	else
		now_page = http_recv_info_p->page;

	debug_log_output("now_page = %d", now_page);

	// 現在表示ページの表示行数計算。
	if ( max_page == now_page ) // 最後のページ
		now_page_line = file_num - (global_param.page_line_max * (max_page-1));
	else	// 最後以外なら、表示最大数。
		now_page_line = global_param.page_line_max;
	debug_log_output("now_page_line = %d", now_page_line);


	// 表示開始ファイル番号計算
	start_file_num = ((now_page - 1) * global_param.page_line_max);
	debug_log_output("start_file_num = %d", start_file_num);

	if ( max_page == now_page ) // 最後のページ
		end_file_num = file_num;
	else // 最後のページではなかったら。
		end_file_num = (start_file_num + global_param.page_line_max);
	debug_log_output("start_file_num = %d", start_file_num);




	// 前ページ番号 計算
	prev_page =  1 ;
	if ( now_page > 1 )
		prev_page = now_page - 1;

	// 次ページ番号 計算
	next_page = max_page ;
	if ( max_page > now_page )
		next_page = now_page + 1;

	debug_log_output("prev_page=%d  next_page=%d", prev_page ,next_page);



	// ===============================
	// スキン置換用データを準備
	// ===============================

	// 作業エリア確保
	skin_rep_data_global_p 	= malloc( sizeof(SKIN_REPLASE_GLOBAL_DATA_T) );
	if ( skin_rep_data_global_p == NULL )
	{
		debug_log_output("malloc() error.");
		return ;
	}
	memset(skin_rep_data_global_p, '\0', sizeof(SKIN_REPLASE_GLOBAL_DATA_T));

	skin_rep_line_malloc_size = sizeof(SKIN_REPLASE_LINE_DATA_T) * (global_param.page_line_max + 1);
	skin_rep_data_line_p 	= malloc( skin_rep_line_malloc_size );
	if ( skin_rep_data_line_p == NULL )
	{
		debug_log_output("malloc() error.");
		return ;
	}
	memset(skin_rep_data_line_p, '\0', sizeof(skin_rep_line_malloc_size));


	// ---------------------------------
	// グローバル 表示用情報 生成開始
	// ---------------------------------

	// 一つ上のディレクトリパス(親パス)を生成。(URIエンコード)
	strncpy(work_data, http_recv_info_p->recv_uri, sizeof(work_data) - strlen(work_data) );
	cut_after_last_character(work_data, '/'); //
	cut_after_last_character(work_data, '/');
	strncat(work_data, "/", sizeof(work_data) - strlen(work_data) ); // '/'を追加。
	debug_log_output("parent_directory='%s'", work_data);

 	uri_encode(skin_rep_data_global_p->parent_directory_link, sizeof(skin_rep_data_global_p->parent_directory_link), work_data, strlen(work_data));

	// '?'を追加
	strncat(skin_rep_data_global_p->parent_directory_link, "?", sizeof(skin_rep_data_global_p->parent_directory_link) - strlen(skin_rep_data_global_p->parent_directory_link));
	// sort=が指示されていた場合、それを引き継ぐ。
	if ( strlen(http_recv_info_p->sort) > 0 )
	{
		snprintf(work_data, sizeof(work_data), "sort=%s&", http_recv_info_p->sort);
		strncat(skin_rep_data_global_p->parent_directory_link, work_data, sizeof(skin_rep_data_global_p->parent_directory_link) - strlen(skin_rep_data_global_p->parent_directory_link));
	}
	debug_log_output("parent_directory_link='%s'", skin_rep_data_global_p->parent_directory_link);


	// 現パス名 表示用生成(文字コード変換)
	strncpy( work_data, http_recv_info_p->recv_uri, sizeof(work_data) );

	if ( global_param.flag_decode_samba_hex_and_cap == TRUE )
	{
		debug_log_output("current_directory_name(cap/hex) = '%s'", work_data);
		decode_samba_hex_and_cap_coding( work_data );
		debug_log_output("current_directory_name(bin) = '%s'", work_data);
	}

	// 現パス名 表示用生成(文字コード変換)
	convert_language_code(	work_data,
							skin_rep_data_global_p->current_directory_name,
							sizeof(skin_rep_data_global_p->current_directory_name),
							global_param.server_language_code,
							global_param.client_language_code );



	debug_log_output("current_dir = '%s'", skin_rep_data_global_p->current_directory_name );


	// 現パス名 Link用生成（URIエンコード）
 	uri_encode(skin_rep_data_global_p->current_directory_link, sizeof(skin_rep_data_global_p->current_directory_link), http_recv_info_p->recv_uri, strlen(http_recv_info_p->recv_uri));

	// ?を追加
	strncat(skin_rep_data_global_p->current_directory_link, "?", sizeof(skin_rep_data_global_p->current_directory_link) - strlen(skin_rep_data_global_p->current_directory_link)); // '?'を追加
	// sort=が指示されていた場合、それを引き継ぐ。
	if ( strlen(http_recv_info_p->sort) > 0 )
	{
		snprintf(work_data, sizeof(work_data), "sort=%s&", http_recv_info_p->sort);
		strncat(skin_rep_data_global_p->current_directory_link, work_data, sizeof(skin_rep_data_global_p->current_directory_link) - strlen(skin_rep_data_global_p->current_directory_link));
	}
	debug_log_output("current_directory_link='%s'", skin_rep_data_global_p->current_directory_link);

	// ディレクトリ存在ファイル数 表示用
	snprintf(skin_rep_data_global_p->file_num_str, sizeof(skin_rep_data_global_p->file_num_str), "%d", file_num );

	// 	現在のページ 表示用
	snprintf(skin_rep_data_global_p->now_page_str, sizeof(skin_rep_data_global_p->now_page_str), "%d", now_page );

	// 全ページ数 表示用
	snprintf(skin_rep_data_global_p->max_page_str, sizeof(skin_rep_data_global_p->max_page_str), "%d", max_page );

	// 次のページ 表示用
	snprintf(skin_rep_data_global_p->next_page_str, sizeof(skin_rep_data_global_p->next_page_str), "%d", next_page );

	// 前のページ 表示用
	snprintf(skin_rep_data_global_p->prev_page_str, sizeof(skin_rep_data_global_p->prev_page_str), "%d", prev_page );

	// 開始ファイル番号表示用
	if ( file_num == 0 )
		snprintf(skin_rep_data_global_p->start_file_num_str, sizeof(skin_rep_data_global_p->start_file_num_str), "%d", start_file_num );
	else
		snprintf(skin_rep_data_global_p->start_file_num_str, sizeof(skin_rep_data_global_p->start_file_num_str), "%d", start_file_num +1 );

	// 終了ファイル番号表示用
	snprintf(skin_rep_data_global_p->end_file_num_str, sizeof(skin_rep_data_global_p->end_file_num_str), "%d", end_file_num  );


	// ディレクトリ同名ファイル削除機能用
	if ( global_param.flag_filename_cut_same_directory_name == TRUE )
	{
		// 現バス名 (ディレクトリ同名ファイル削除機能で使用)
		convert_language_code(	http_recv_info_p->recv_uri,
								skin_rep_data_global_p->euc_current_dir_name,
								sizeof(skin_rep_data_global_p->euc_current_dir_name),
								global_param.server_language_code,
								CODE_EUC );

		// 最後に'/'が付いていたら削除
		cut_character_at_linetail(skin_rep_data_global_p->euc_current_dir_name, '/' );
		// '/'より前を削除
		cut_before_last_character(skin_rep_data_global_p->euc_current_dir_name, '/' );

		debug_log_output("euc_current_dir = '%s'", skin_rep_data_global_p->euc_current_dir_name );
	}


	skin_rep_data_global_p->stream_files = 0;	// 再生可能ファイル数カウント用

	// ---------------------------------
	// ファイル表示用情報 生成開始
	// ---------------------------------
	for ( i=start_file_num, count=0; i<(start_file_num + now_page_line) ; i++, count++ )
	{
		// --------------------------------------------------------------------------------
		// 拡張子無しファイル名（表示用） 生成
		// ファイル名 長さ制限に合わせてCutもやる
		// ファイル名 → EUCコードに → 拡張子Cut → 文字列Cut → MediaWiz文字コードに
		// --------------------------------------------------------------------------------

		// EUCに。
		convert_language_code( 	file_info_p[i].name,
								work_data,
								sizeof(work_data),
								global_param.server_language_code,
								CODE_EUC);

		// 拡張子、有ればカット
		if ( strchr(work_data, '.') != NULL )
		{
			cut_after_last_character(work_data, '.');
		}
		debug_log_output("file_name_no_ext='%s'\n", work_data);


		// ()[]の削除フラグチェック
		// フラグがTRUEで、ファイルがディレクトリでなければ、括弧を削除する。

		if (( S_ISDIR( file_info_p[i].type ) == 0 ) &&
		    ( global_param.flag_filename_cut_parenthesis_area == TRUE ))
		{
			cut_enclose_words(work_data, sizeof(work_data), "(", ")");
			cut_enclose_words(work_data, sizeof(work_data), "[", "]");
			debug_log_output("file_name_no_ext(enclose_words)='%s'\n", work_data);
		}

		// ディレクトリ同名文字列削除フラグチェック
		// フラグがTRUEで、ファイルがディレクトリでなければ、同一文字列を削除。
		if (( S_ISDIR( file_info_p[i].type ) == 0 ) 						&&
		    ( global_param.flag_filename_cut_same_directory_name == TRUE ) 	&&
		    ( strlen(skin_rep_data_global_p->euc_current_dir_name) > 0 )		)
		{

			// ディレクトリ同名文字列を""で置換
			replase_character(work_data, sizeof(work_data), skin_rep_data_global_p->euc_current_dir_name, "");

			// 頭に' 'が付いているようならば削除。
			cut_first_character(work_data, ' ');

			debug_log_output("file_name_no_ext(cut_same_directory_name)='%s'\n", work_data);
		}

		// 長さ制限を超えていたらCut
		debug_log_output("file_name_no_ext length=%d, menu_filename_length_max=%d", strlen(work_data) , global_param.menu_filename_length_max);
		if ( strlen(work_data) > global_param.menu_filename_length_max )
		{
			// CUT実行
			euc_string_cut_n_length(work_data, global_param.menu_filename_length_max);
			debug_log_output("file_name_no_ext(cut)='%s'\n", work_data);
		}

		// MediaWiz文字コードに
		convert_language_code(	work_data,
								skin_rep_data_line_p[count].file_name_no_ext,
								sizeof(skin_rep_data_line_p[count].file_name_no_ext),
								CODE_AUTO,
								global_param.client_language_code);

		debug_log_output("file_name_no_ext='%s'\n", skin_rep_data_line_p[count].file_name_no_ext);

		// ファイル名(拡張子無し) 生成終了
		// --------------------------------------


		// --------------------------------------------------------------------------------
		// 拡張子だけ生成
		// --------------------------------------------------------------------------------
		filename_to_extension(file_info_p[i].name, skin_rep_data_line_p[count].file_extension, sizeof(skin_rep_data_line_p[count].file_extension));
		debug_log_output("file_extension='%s'\n", skin_rep_data_line_p[count].file_extension);

		// --------------------------------------------------------------------------------
		// ファイル名 生成 (表示用)  (no_extとextをくっつける)
		// --------------------------------------------------------------------------------
		strncpy(skin_rep_data_line_p[count].file_name, skin_rep_data_line_p[count].file_name_no_ext, sizeof(skin_rep_data_line_p[count].file_name));
		if ( strlen(skin_rep_data_line_p[count].file_extension) > 0 )
		{
			strncat(skin_rep_data_line_p[count].file_name, ".", sizeof(skin_rep_data_line_p[count].file_name));
			strncat(skin_rep_data_line_p[count].file_name, skin_rep_data_line_p[count].file_extension, sizeof(skin_rep_data_line_p[count].file_name));
		}

		// --------------------------------------------------------------------------------
		// Link用URI(エンコード済み) を生成
		// --------------------------------------------------------------------------------
		strncpy(work_data, http_recv_info_p->recv_uri, sizeof(work_data) );
		strncat(work_data, file_info_p[i].org_name, sizeof(work_data) - strlen(work_data) );
	 	uri_encode(skin_rep_data_line_p[count].file_uri_link, sizeof(skin_rep_data_line_p[count].file_uri_link), work_data, strlen(work_data) );
		debug_log_output("file_uri_link='%s'\n", skin_rep_data_line_p[count].file_uri_link);


		// --------------------------------------------------------------------------------
		// ファイルスタンプの日時文字列を生成。
		// --------------------------------------------------------------------------------
		conv_time_to_string(skin_rep_data_line_p[count].file_timestamp, file_info_p[i].time );
		conv_time_to_date_string(skin_rep_data_line_p[count].file_timestamp_date, file_info_p[i].time );
		conv_time_to_time_string(skin_rep_data_line_p[count].file_timestamp_time, file_info_p[i].time );





		// --------------------------------------------------------------------------------
		// ファイルサイズ表示用文字列生成
		// --------------------------------------------------------------------------------
		conv_num_to_unit_string(skin_rep_data_line_p[count].file_size_string, file_info_p[i].size );
		debug_log_output("'%s'", skin_rep_data_line_p[count].file_size_string );

		// --------------------------------------------------------------------------------
		// tvid 表示用文字列生成
		// --------------------------------------------------------------------------------
		snprintf(skin_rep_data_line_p[count].tvid_string, sizeof(skin_rep_data_line_p[count].tvid_string), "%d", i+1 );

		// --------------------------------------------------------------------------------
		// vod_string 表示用文字列 とりあえず、""を。
		// --------------------------------------------------------------------------------
		strncpy(skin_rep_data_line_p[count].vod_string, "", sizeof(skin_rep_data_line_p[count].vod_string) );


		// =========================================================
		// ファイルタイプ判定処理
		// =========================================================
		if ( S_ISDIR( file_info_p[i].type ) != 0 ) // ディレクトリか？
		{

			skin_rep_data_line_p[count].stream_type = TYPE_NO_STREAM;
			skin_rep_data_line_p[count].menu_file_type = TYPE_DIRECTORY;
		}
		else // ディレクトリ以外
		{
			skin_rep_data_line_p[count].menu_file_type = TYPE_UNKNOWN;
			for (j=0;;j++)
			{
				if (( mime_list[j].mime_name == NULL ) || ( strlen(skin_rep_data_line_p[count].file_extension) == 0 ) )
					break;

				if ( strcasecmp(mime_list[j].file_extension, skin_rep_data_line_p[count].file_extension) == 0 )
				{
					skin_rep_data_line_p[count].stream_type = mime_list[j].stream_type;
					skin_rep_data_line_p[count].menu_file_type = mime_list[j].menu_file_type;
					break;
				}
			}
		}


		// =========================================================
		// ファイルタイプ毎に必要な文字列を追加で生成
		// =========================================================

		// ----------------------------
		// ディレクトリ 特定処理
		// ----------------------------
		if ( skin_rep_data_line_p[count].menu_file_type == TYPE_DIRECTORY )
		{
			// '?'を追加する。
			strncat(skin_rep_data_line_p[count].file_uri_link, "?", sizeof(skin_rep_data_line_p[count].file_uri_link) - strlen(skin_rep_data_line_p[count].file_uri_link));

			// sort=が指示されていた場合、それを引き継ぐ。
			if ( strlen(http_recv_info_p->sort) > 0 )
			{
				snprintf(work_data, sizeof(work_data), "sort=%s&", http_recv_info_p->sort);
				strncat(skin_rep_data_line_p[count].file_uri_link, work_data, sizeof(skin_rep_data_line_p[count].file_uri_link) - strlen(skin_rep_data_line_p[count].file_uri_link));
			}

		}

		// -------------------------------------
		// ストリームファイル 特定処理
		// -------------------------------------
		if ( skin_rep_data_line_p[count].stream_type == TYPE_STREAM )
		{
			// vod_string に"vod="0" をセット
			strncpy(skin_rep_data_line_p[count].vod_string, "vod=\"0\"", sizeof(skin_rep_data_line_p[count].vod_string) );

			// 拡張子置き換え処理。
			extension_add_rename(skin_rep_data_line_p[count].file_uri_link);

			// 再生可能ファイルカウント
			skin_rep_data_global_p->stream_files++;


			// -------------------------------------
			// SVIファイル 追加 特定処理
			// -------------------------------------
			if ( skin_rep_data_line_p[count].menu_file_type == TYPE_SVI )
			{
				// ------------------------------
				// SVIから情報を引き抜く。
				// ------------------------------

				// SVIファイルのフルパス生成
				strncpy(work_filename, http_recv_info_p->send_filename, sizeof(work_filename) );
				if ( work_filename[strlen(work_filename)-1] != '/' )
				{
					strncat(work_filename, "/", sizeof(work_filename) - strlen(work_filename) );
				}
				strncat(work_filename, file_info_p[i].org_name, sizeof(work_filename) - strlen(work_filename));

				// --------------------------------------------------
				// SVIファイルから情報をゲットして、文字コード変換。
				// 長さ制限に合わせてCut
				// ※ EUCに変換 → Cut → MediaWiz文字コードへ変換
				// --------------------------------------------------
				read_svi_info(work_filename, skin_rep_data_line_p[count].svi_info_data, sizeof(skin_rep_data_line_p[count].svi_info_data),  &rec_time );
				if ( strlen(skin_rep_data_line_p[count].svi_info_data) > 0 )
				{
					convert_language_code(	skin_rep_data_line_p[count].svi_info_data,
											work_data,
											sizeof(work_data),
											CODE_AUTO,
											CODE_EUC );

					if ( strlen(work_data) > global_param.menu_svi_info_length_max )
					{
						// CUT実行
						euc_string_cut_n_length(work_data, global_param.menu_svi_info_length_max);
					}
					// MediaWiz文字コードに
					convert_language_code(	work_data,
											skin_rep_data_line_p[count].svi_info_data,
											sizeof(skin_rep_data_line_p[count].svi_info_data),
											CODE_AUTO,
											global_param.client_language_code);
				}
				debug_log_output("svi_info_data='%s'\n", skin_rep_data_line_p[count].svi_info_data);

				// SVIから読んだ録画時間を、文字列に。
				snprintf(skin_rep_data_line_p[count].svi_rec_time_data, sizeof(skin_rep_data_line_p[count].svi_rec_time_data),
							"%02d:%02d:%02d", rec_time /3600, (rec_time % 3600) / 60, rec_time % 60 );
			}

			// ----------------------------
			// playlistファイル 特定処理
			// ----------------------------
			if ( (strcasecmp(skin_rep_data_line_p[count].file_extension, "plw") == 0) ||
				 (strcasecmp(skin_rep_data_line_p[count].file_extension, "upl") == 0) 	)
			{
				// vod_string に "vod="playlist"をセット
				strncpy(skin_rep_data_line_p[count].vod_string, "vod=\"playlist\"", sizeof(skin_rep_data_line_p[count].vod_string) );

			}



		}


		// ----------------------------
		// IMAGEファイル特定処理
		// ----------------------------
		if ( skin_rep_data_line_p[count].menu_file_type == TYPE_IMAGE )
		{
			// ----------------------------------
			// イメージファイルのフルパス生成
			// ----------------------------------
			strncpy(work_filename, http_recv_info_p->send_filename, sizeof(work_filename) );
			if ( work_filename[strlen(work_filename)-1] != '/' )
			{
				strncat(work_filename, "/", sizeof(work_filename) - strlen(work_filename) );
			}
			strncat(work_filename, file_info_p[i].org_name, sizeof(work_filename) - strlen(work_filename));
			debug_log_output("work_filename(image) = %s", work_filename);



			// ------------------------
			// イメージのサイズをGET
			// ------------------------

			image_width = 0;
			image_height = 0;

			// 拡張子で分岐
			if ( (strcasecmp( skin_rep_data_line_p[count].file_extension, "jpg" ) == 0 ) ||
				 (strcasecmp( skin_rep_data_line_p[count].file_extension, "jpeg" ) == 0 ))
			{
				// JPEGファイルのサイズをGET
				jpeg_size( work_filename, &image_width, &image_height );
			}
			else if (strcasecmp( skin_rep_data_line_p[count].file_extension, "gif" ) == 0 )
			{
				// GIFファイルのサイズをGET
				gif_size( work_filename, &image_width, &image_height );
			}
			else if (strcasecmp( skin_rep_data_line_p[count].file_extension, "png" ) == 0 )
			{
				// PNGファイルのサイズをGET
				png_size( work_filename, &image_width, &image_height );
			}

			// 画像サイズを文字列に、
			snprintf(skin_rep_data_line_p[count].image_width, sizeof(skin_rep_data_line_p[count].image_width), "%d", image_width );
			snprintf(skin_rep_data_line_p[count].image_height, sizeof(skin_rep_data_line_p[count].image_height), "%d", image_height );

			// ----------------------------------
			// リンクの最後に'?'を追加する。
			// ----------------------------------
			strncat(skin_rep_data_line_p[count].file_uri_link, "?", sizeof(skin_rep_data_line_p[count].file_uri_link) - strlen(skin_rep_data_line_p[count].file_uri_link));

			// sort=が指示されていた場合、それを引き継ぐ。
			if ( strlen(http_recv_info_p->sort) > 0 )
			{
				snprintf(work_data, sizeof(work_data), "sort=%s&", http_recv_info_p->sort);
				strncat(skin_rep_data_line_p[count].file_uri_link, work_data, sizeof(skin_rep_data_line_p[count].file_uri_link) - strlen(skin_rep_data_line_p[count].file_uri_link));
			}
		}


		// -------------------------------------
		// MUSICファイル 特定処理
		// -------------------------------------
		if (skin_rep_data_line_p[count].menu_file_type == TYPE_MUSIC)
		{
			// vod_string に "vod="playlist"をセット
			strncpy(skin_rep_data_line_p[count].vod_string, "vod=\"playlist\"", sizeof(skin_rep_data_line_p[count].vod_string) );

			// リンクの最後に'?action=SinglePlay&'を追加する。
			strncat(skin_rep_data_line_p[count].file_uri_link, "?action=SinglePlay&", sizeof(skin_rep_data_line_p[count].file_uri_link) - strlen(skin_rep_data_line_p[count].file_uri_link));
		}




		// -------------------------------------
		// MP3ファイル 特定処理
		// -------------------------------------
		if ( (skin_rep_data_line_p[count].menu_file_type == TYPE_MUSIC) &&
			 (strcasecmp(skin_rep_data_line_p[count].file_extension, "mp3") == 0) )
		{

			// ----------------------------------
			// MP3ファイルのフルパス生成
			// ----------------------------------
			strncpy(work_filename, http_recv_info_p->send_filename, sizeof(work_filename) );
			if ( work_filename[strlen(work_filename)-1] != '/' )
			{
				strncat(work_filename, "/", sizeof(work_filename) - strlen(work_filename) );
			}
			strncat(work_filename, file_info_p[i].org_name, sizeof(work_filename) - strlen(work_filename));
			debug_log_output("work_filename(mp3) = %s", work_filename);


			// ------------------------
			// MP3のID3V1データをGET
			// ------------------------
			mp3_id3v1_tag_read(work_filename, &(skin_rep_data_line_p[count]) );

			// for Debug.
			if ( skin_rep_data_line_p[count].mp3_id3v1_flag > 0 )
			{
				debug_log_output("mp3 title:'%s'", 		skin_rep_data_line_p[count].mp3_id3v1_title);
				debug_log_output("mp3 album:'%s'", 		skin_rep_data_line_p[count].mp3_id3v1_album);
				debug_log_output("mp3 artist:'%s'", 	skin_rep_data_line_p[count].mp3_id3v1_artist);
				debug_log_output("mp3 year:'%s'", 		skin_rep_data_line_p[count].mp3_id3v1_year);
				debug_log_output("mp3 comment:'%s'",	skin_rep_data_line_p[count].mp3_id3v1_comment);
				debug_log_output("mp3 title_info:'%s'",	skin_rep_data_line_p[count].mp3_id3v1_title_info);
				debug_log_output("mp3 title_info_limited:'%s'",	skin_rep_data_line_p[count].mp3_id3v1_title_info_limited);
			}

		}
	}

	debug_log_output("\ncount=%d", count);



	// ============================
	// 隠しディレクトリ検索
	// ============================

	memset(skin_rep_data_global_p->secret_dir_link_html, '\0', sizeof(skin_rep_data_global_p->secret_dir_link_html));

	// 隠しディレクトリが存在しているかチェック。
	for ( i=0; i<SECRET_DIRECTORY_MAX; i++)
	{
		if ( strlen(secret_directory_list[i].dir_name) > 0 )	// 隠しディレクトリ指定有り？
		{
			// ----------------------------------
			// 隠しディレクトリのフルパス生成
			// ----------------------------------
			strncpy(work_filename, http_recv_info_p->send_filename, sizeof(work_filename) );
			if ( work_filename[strlen(work_filename)-1] != '/' )
			{
				strncat(work_filename, "/", sizeof(work_filename) - strlen(work_filename) );
			}
			strncat(work_filename, secret_directory_list[i].dir_name, sizeof(work_filename) - strlen(work_filename));
			debug_log_output("check: work_filename = %s", work_filename);

			// 存在チェック
			result = stat(work_filename, &dir_stat);
			if ( result == 0 )
			{
				if ( S_ISDIR(dir_stat.st_mode) != 0 ) // ディレクトリ存在！
				{
					// 存在してたら、リンク用URI生成
					strncpy(work_data, http_recv_info_p->recv_uri, sizeof(work_data) );
					strncat(work_data, secret_directory_list[i].dir_name, sizeof(work_data) - strlen(work_data) );
	 				uri_encode(work_data2, sizeof(work_data2), work_data, strlen(work_data) );

					// HTML生成
					snprintf(work_data, sizeof(work_data), "<a href=\"%s\" tvid=%d></a> ", work_data2, secret_directory_list[i].tvid);

					debug_log_output("secret_dir_html='%s'", work_data);
					strncat( skin_rep_data_global_p->secret_dir_link_html, work_data, sizeof(skin_rep_data_global_p->secret_dir_link_html) - strlen(skin_rep_data_global_p->secret_dir_link_html) );

				}
			}
		}
		else
		{
			break;
		}
	}
	debug_log_output("secret_dir_html='%s'", skin_rep_data_global_p->secret_dir_link_html);


	// ======================================================================================
	// ======================================================================================
	//  スキンデータ処理開始。
	// ======================================================================================
	// ======================================================================================




	// ===============================
	// HEAD スキンファイル 読み込み
	// ===============================

	// HEAD スキンファイル名生成
	strncpy(read_filename, skin_path, sizeof(read_filename) );
	strncat(read_filename, SKIN_MENU_HEAD_HTML, sizeof(read_filename) - strlen(read_filename) );
	debug_log_output("skin: read_filename='%s'", read_filename);

	// ファイル読み込み
	menu_head_skin_p = skin_file_read(read_filename, &menu_head_skin_malloc_size );
	if ( menu_head_skin_p == NULL )
	{
		debug_log_output("skin_file_read() error.");
		return ;
	}

	// ------------------------------------------------------------
	//  HEAD 置換処理
	// ------------------------------------------------------------
	replase_skin_grobal_data(menu_head_skin_p, menu_head_skin_malloc_size, skin_rep_data_global_p);

	// ----------------------
	// 結果をコピー
	// ----------------------
	strncpy(send_filemenu_buf, menu_head_skin_p, buf_size );
	free(menu_head_skin_p);
	debug_log_output("skin: free() end." );



	// ====================================
	// LINE 置換処理
	// ====================================

	// 作業エリア確保
	menu_work_p = malloc(buf_size);
	if ( menu_work_p == NULL)
	{
		debug_log_output("malloc() error.");
		return;
	}


	// ===============================
	// スキンデータ読み込み
	// ===============================


	// DIRスキン 読み込み
	strncpy(read_filename, skin_path, sizeof(read_filename) );
	strncat(read_filename, SKIN_MENU_LINE_DIR_HTML, sizeof(read_filename)-strlen(read_filename) );
	debug_log_output("skin: read_filename='%s'", read_filename);
	menu_line_dir_skin_p = skin_file_read( read_filename, &menu_line_dir_skin_malloc_size );
	if ( menu_line_dir_skin_p == NULL )
	{
		debug_log_output("skin_file_read() error.");
		return;
	}

	// MOVIE スキン読み込み
	strncpy(read_filename, skin_path, sizeof( read_filename) );
	strncat(read_filename, SKIN_MENU_LINE_MOVIE_FILE_HTML, sizeof(read_filename) - strlen(read_filename) );
	debug_log_output("skin: read_filename='%s'", read_filename);
	menu_line_movie_skin_p = skin_file_read( read_filename, &menu_line_movie_skin_malloc_size );
	if ( menu_line_movie_skin_p == NULL )
	{
		debug_log_output("skin_file_read() error.");
		return;
	}

	// MUSIC スキン読み込み
	strncpy(read_filename, skin_path, sizeof( read_filename) );
	strncat(read_filename, SKIN_MENU_LINE_MUSIC_FILE_HTML, sizeof(read_filename) - strlen(read_filename) );
	debug_log_output("skin: read_filename='%s'", read_filename);
	menu_line_music_skin_p = skin_file_read( read_filename, &menu_line_music_skin_malloc_size );
	if ( menu_line_music_skin_p == NULL )
	{
		debug_log_output("skin_file_read() error.");
		return;
	}

	// IMAGE スキン読み込み
	strncpy(read_filename, skin_path, sizeof( read_filename) );
	strncat(read_filename, SKIN_MENU_LINE_IMAGE_FILE_HTML, sizeof(read_filename) - strlen(read_filename) );
	debug_log_output("skin: read_filename='%s'", read_filename);
	menu_line_image_skin_p = skin_file_read( read_filename, &menu_line_image_skin_malloc_size );
	if ( menu_line_image_skin_p == NULL )
	{
		debug_log_output("skin_file_read() error.");
		return;
	}

	// DOCUMENT スキン読み込み
	strncpy(read_filename, skin_path, sizeof( read_filename) );
	strncat(read_filename, SKIN_MENU_LINE_DOCUMENT_FILE_HTML, sizeof(read_filename) - strlen(read_filename) );
	debug_log_output("skin: read_filename='%s'", read_filename);
	menu_line_document_skin_p = skin_file_read( read_filename, &menu_line_document_skin_malloc_size );
	if ( menu_line_document_skin_p == NULL )
	{
		debug_log_output("skin_file_read() error.");
		return;
	}

	// UNKNOWN スキン読み込み
	strncpy(read_filename, skin_path, sizeof( read_filename) );
	strncat(read_filename, SKIN_MENU_LINE_UNKNOWN_FILE_HTML, sizeof(read_filename) - strlen(read_filename) );
	debug_log_output("skin: read_filename='%s'", read_filename);
	menu_line_unknown_skin_p = skin_file_read( read_filename, &menu_line_unknown_skin_malloc_size );
	if ( menu_line_unknown_skin_p == NULL )
	{
		debug_log_output("skin_file_read() error.");
		return;
	}


	// SVI スキン読み込み
	strncpy(read_filename, skin_path, sizeof( read_filename) );
	strncat(read_filename, SKIN_MENU_LINE_SVI_FILE_HTML, sizeof(read_filename) - strlen(read_filename) );
	debug_log_output("skin: read_filename='%s'", read_filename);
	menu_line_svi_skin_p = skin_file_read(read_filename, &menu_line_svi_skin_malloc_size );
	if ( menu_line_svi_skin_p == NULL )
	{
		debug_log_output("skin_file_read() error.");
		return;
	}

	// =================================
	//  処理開始。
	// =================================
	for ( count=0; count< now_page_line;  count++ )
	{

		// --------------------------------------------------------
		// ファイルタイプにより、対応するスキンデータをcopy
		// --------------------------------------------------------

		if ( skin_rep_data_line_p[count].menu_file_type == TYPE_DIRECTORY )	// ディレクトリ
		{
			strncpy(menu_work_p, menu_line_dir_skin_p, buf_size );
		}
		else if ( skin_rep_data_line_p[count].menu_file_type == TYPE_MOVIE ) // MOVIE
		{
			strncpy(menu_work_p, menu_line_movie_skin_p, buf_size );
		}
		else if ( skin_rep_data_line_p[count].menu_file_type == TYPE_MUSIC ) // MUSIC
		{
			strncpy(menu_work_p, menu_line_music_skin_p, buf_size );
		}
		else if ( skin_rep_data_line_p[count].menu_file_type == TYPE_IMAGE ) // IMAGE
		{
			strncpy(menu_work_p, menu_line_image_skin_p, buf_size );
		}
		else if ( skin_rep_data_line_p[count].menu_file_type == TYPE_DOCUMENT ) // DOCUMENT
		{
			strncpy(menu_work_p, menu_line_document_skin_p, buf_size );
		}
		else if ( skin_rep_data_line_p[count].menu_file_type == TYPE_SVI )		// SVI
		{
			strncpy(menu_work_p, menu_line_svi_skin_p, buf_size );
		}
		else	// Unknown
		{
			strncpy(menu_work_p, menu_line_unknown_skin_p, buf_size );
		}


		// -----------------------------
		// LINE 置換処理
		// -----------------------------
		replase_skin_line_data(menu_work_p, buf_size, &(skin_rep_data_line_p[count]) );
		replase_skin_grobal_data(menu_work_p, buf_size, skin_rep_data_global_p);


		// ------------------------------
		// FILE_NAME 結果をコピー
		// ------------------------------
		strncat(send_filemenu_buf, menu_work_p, buf_size );
	}

	// 作業領域解放
	free( menu_work_p );
	free( menu_line_movie_skin_p );
	free( menu_line_music_skin_p );
	free( menu_line_image_skin_p );
	free( menu_line_document_skin_p );
	free( menu_line_unknown_skin_p );
	free( menu_line_svi_skin_p );
	free( menu_line_dir_skin_p );



	// =======================
	// TAIL ファイル名
	// =======================

	// ファイル名生成
	strncpy(read_filename, skin_path, sizeof(read_filename) );
	strncat(read_filename, SKIN_MENU_TAIL_HTML, sizeof(read_filename) - strlen(read_filename) );
	debug_log_output("skin: read_filename='%s'", read_filename);

	// ファイル読み込み
	menu_tail_skin_p = skin_file_read( read_filename,  &menu_tail_skin_malloc_size );
	if ( menu_tail_skin_p == NULL )
	{
		debug_log_output("skin_file_read() error.");
		return;
	}

	// ------------------------------------------------------------
	// ============================================================
	//  TAIL 置換処理
	// ============================================================
	// ------------------------------------------------------------
	replase_skin_grobal_data(menu_tail_skin_p, menu_tail_skin_malloc_size, skin_rep_data_global_p);


	// ---------------
	// 結果をコピー
	// ---------------
	strncat(send_filemenu_buf, menu_tail_skin_p, buf_size - strlen(send_filemenu_buf));

	free(menu_tail_skin_p);



	free( skin_rep_data_global_p );
	free( skin_rep_data_line_p );


	return;
}





// **************************************************************************
// 全体用データ まとめて置換
// **************************************************************************
static void replase_skin_grobal_data(unsigned char *menu_work_p, int menu_work_buf_size, SKIN_REPLASE_GLOBAL_DATA_T *skin_rep_data_global_p)
{

	// ===============================
	// = 削除キーワードを削除する
	// ===============================

	// ルートパスの場合。
	if ( strcmp(skin_rep_data_global_p->current_directory_name, "/" ) == 0 )
	{
		//debug_log_output("SKIN_KEYWORD_DEL_IS_ROOTDIR hit.");
		cut_enclose_words(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_DEL_IS_ROOTDIR, SKIN_KEYWORD_DEL_IS_ROOTDIR_E);
	}

	// １ページの場合
	if ( strcmp(skin_rep_data_global_p->now_page_str, "1" ) == 0 )
	{
		//debug_log_output("SKIN_KEYWORD_DEL_IS_NO_PAGE_PREV hit.");
		cut_enclose_words(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_DEL_IS_NO_PAGE_PREV, SKIN_KEYWORD_DEL_IS_NO_PAGE_PREV_E);
	}

	// 最後のページの場合
	if ( strcmp(skin_rep_data_global_p->now_page_str, skin_rep_data_global_p->max_page_str) == 0 )
	{
		//debug_log_output("SKIN_KEYWORD_DEL_IS_NO_PAGE_NEXT hit.");
		cut_enclose_words(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_DEL_IS_NO_PAGE_NEXT, SKIN_KEYWORD_DEL_IS_NO_PAGE_NEXT_E);
	}

	// 再生可能ファイル数が０の場合
	if ( skin_rep_data_global_p->stream_files == 0 )
	{
		//debug_log_output("SKIN_KEYWORD_DEL_IS_NO_STREAM_FILES hit.");
		cut_enclose_words(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_DEL_IS_NO_STREAM_FILES, SKIN_KEYWORD_DEL_IS_NO_STREAM_FILES_E);
	}



	// =============
	// = 置換実行
	// =============

	// SERVER_NAME
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_SERVER_NAME, SERVER_NAME);

	// CURRENT_PATH 現在のパス（表示用）
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_CURRENT_PATH, skin_rep_data_global_p->current_directory_name);

	// CURRENT_PATH_LINK	現在のパス（LINK用 URIエンコード）
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_CURRENT_PATH_LINK, skin_rep_data_global_p->current_directory_link);

	// SKIN_KEYWORKD_PARLENT_DIR_LINK 	親ディレクトリ(LINK用 URIエンコード)
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORKD_PARLENT_DIR_LINK, skin_rep_data_global_p->parent_directory_link );

	// SKIN_KEYWORD_CURRENT_PAGE	 	現在のページ
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_CURRENT_PAGE, skin_rep_data_global_p->now_page_str);

	// SKIN_KEYWORD_MAX_PAGE			全ページ数
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_MAX_PAGE, skin_rep_data_global_p->max_page_str);

	// SKIN_KEYWORD_NEXT_PAGE			次のページ
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_NEXT_PAGE, skin_rep_data_global_p->next_page_str);

	// SKIN_KEYWORD_BACK_PAGE			前のページ
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_PREV_PAGE, skin_rep_data_global_p->prev_page_str);

	// SKIN_KEYWORD_FILE_NUM			 ディレクトリ存在ファイル数
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_FILE_NUM, skin_rep_data_global_p->file_num_str);

	// SKIN_KEYWORD_START_FILE_NUM		 表示開始ファイル番号
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_START_FILE_NUM, skin_rep_data_global_p->start_file_num_str);

	// SKIN_KEYWORD_END_FILE_NUM		 表示終了ファイル番号
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_END_FILE_NUM, skin_rep_data_global_p->end_file_num_str);


	// SKIN_KEYWORD_SECRET_DIR_LINK		隠しディレクトリ
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_SECRET_DIR_LINK, skin_rep_data_global_p->secret_dir_link_html );

	return;
}

// **************************************************************************
// ライン用データ まとめて置換
// **************************************************************************
static void replase_skin_line_data(unsigned char *menu_work_p, int menu_work_buf_size, SKIN_REPLASE_LINE_DATA_T *skin_rep_data_line_p)
{


	// ===============================
	// = 削除キーワードを削除する
	// ===============================

	// MP3タグ無い場合
	if ( skin_rep_data_line_p->mp3_id3v1_flag == 0 )
	{
		// debug_log_output("SKIN_KEYWORD_DEL_IS_NO_MP3_TAGS hit.");
		cut_enclose_words(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_DEL_IS_NO_MP3_TAGS, SKIN_KEYWORD_DEL_IS_NO_MP3_TAGS_E);
	}
	else // MP3タグ存在してる場合
	{
		cut_enclose_words(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_DEL_IS_HAVE_MP3_TAGS, SKIN_KEYWORD_DEL_IS_HAVE_MP3_TAGS_E);
		
	}



	// =============
	//  置換実行
	// =============

	// SKIN_KEYWORD_LINE_FILE_NAME	ファイル名 表示用
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_LINE_FILE_NAME, skin_rep_data_line_p->file_name );

	// SKIN_KEYWORD_LINE_FILE_NAME_NO_EXT	ファイル名(拡張子無し) 表示用
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_LINE_FILE_NAME_NO_EXT, skin_rep_data_line_p->file_name_no_ext );

	// SKIN_KEYWORD_LINE_FILE_EXT	ファイル拡張子名 表示用
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_LINE_FILE_EXT, skin_rep_data_line_p->file_extension );

	// SKIN_KEYWORD_LINE_FILE_LINK	ファイル名 LINK用
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_LINE_FILE_LINK, skin_rep_data_line_p->file_uri_link );

	// SKIN_KEYWORD_LINE_TIMESTAMP	  日時 表示用
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_LINE_TIMESTAMP, skin_rep_data_line_p->file_timestamp );

	// SKIN_KEYWORD_LINE_FILE_DATE	  日付 表示用
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_LINE_FILE_DATE, skin_rep_data_line_p->file_timestamp_date );

	// SKIN_KEYWORD_LINE_FILE_TIME	  時刻 表示用
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_LINE_FILE_TIME, skin_rep_data_line_p->file_timestamp_time );

	// SKIN_KEYWORD_LINE_TVID		TVID 表示用
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_LINE_TVID, skin_rep_data_line_p->tvid_string );

	// SKIN_KEYWORD_LINE_FILE_VOD	vod="0"  必要に応じて付く。
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_LINE_FILE_VOD, skin_rep_data_line_p->vod_string );

	// SKIN_KEYWORD_LINE_FILE_SIZE	ファイルサイズ 表示用
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_LINE_FILE_SIZE,  skin_rep_data_line_p->file_size_string );

	// SKIN_KEYWORD_LINE_SVI_INFO	SVI情報 表示用
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_LINE_SVI_INFO,  skin_rep_data_line_p->svi_info_data );

	// SKIN_KEYWORD_LINE_SVI_INFO	SVI情報 表示用
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_LINE_SVI_REC_TIME,  skin_rep_data_line_p->svi_rec_time_data );

	// SKIN_KEYWORD_LINE_IMAGE_WIDTH	画像の横幅
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_LINE_IMAGE_WIDTH,  skin_rep_data_line_p->image_width );

	// SKIN_KEYWORD_LINE_IMAGE_HEIGHT	画像の高さ
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_LINE_IMAGE_HEIGHT,  skin_rep_data_line_p->image_height );

	// SKIN_KEYWORD_LINE_MP3TAG_TITLE		MP3タグ タイトル
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_LINE_MP3TAG_TITLE,	skin_rep_data_line_p->mp3_id3v1_title	);

	// SKIN_KEYWORD_LINE_MP3TAG_ALBUM		MP3タグ アルバム名
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_LINE_MP3TAG_ALBUM,	skin_rep_data_line_p->mp3_id3v1_album	);

	// SKIN_KEYWORD_LINE_MP3TAG_ARTIST		MP3タグ アーティスト
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_LINE_MP3TAG_ARTIST,	skin_rep_data_line_p->mp3_id3v1_artist	);

	// SKIN_KEYWORD_LINE_MP3TAG_YEAR		MP3タグ 制作年度
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_LINE_MP3TAG_YEAR,	skin_rep_data_line_p->mp3_id3v1_year	);

	// SKIN_KEYWORD_LINE_MP3TAG_COMMENT		MP3タグ コメント
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_LINE_MP3TAG_COMMENT,skin_rep_data_line_p->mp3_id3v1_comment	);

	// SKIN_KEYWORD_LINE_MP3TAG_TITLE_INFO		MP3タグ タイトル情報(字数制限付き)
	replase_character(menu_work_p, menu_work_buf_size, SKIN_KEYWORD_LINE_MP3TAG_TITLE_INFO,	skin_rep_data_line_p->mp3_id3v1_title_info_limited	);

	return;
}




// **************************************************************************
// スキンファイルを読み込む。
//
//  ファイルサイズにあわせて、malloc()
//  文字コード変換。
// **************************************************************************
static unsigned char *skin_file_read(unsigned char *read_filename, int *malloc_size )
{
	int		fd;
	struct stat		file_stat;
	int				result;
	ssize_t			read_size;
	unsigned char 	*read_work_buf;
	unsigned char 	*read_buf;



	// ファイルサイズチェック
	result = stat(read_filename, &file_stat);
	debug_log_output("skin: head stat()=%d, st_size=%lld", result, file_stat.st_size );
	if ( result != 0 )
	{
		debug_log_output("stat(%s) error.", read_filename);
		return NULL;
	}

	// ファイルサイズの6倍の領域をmalloc(２つ)
	*malloc_size = file_stat.st_size * 6 ;

	read_work_buf = malloc( *malloc_size );
	if ( read_work_buf == NULL )
	{
		debug_log_output("maloc() error.");
		return NULL;
	}

	read_buf = malloc( *malloc_size );
	if ( read_buf == NULL )
	{
		debug_log_output("maloc() error.");
		return NULL;
	}

	memset(read_work_buf, '\0', *malloc_size);
	memset(read_buf, '\0', *malloc_size);

	// ファイル読み込み
	fd = open(read_filename, O_RDONLY );
	if ( fd < 0 )
	{
		debug_log_output("open() error.");
		free(read_buf);
		free(read_work_buf);
		return NULL;
	}

	read_size = read(fd, read_work_buf, file_stat.st_size );
	debug_log_output("skin: read() read_size=%d", read_size );

	if ( read_size != file_stat.st_size )
	{
		debug_log_output("read() error.");
		free(read_buf);
		free(read_work_buf);
		return NULL;
	}

	close( fd );

	// 読んだデータの文字コードを、MediaWiz用コードに変換
	convert_language_code(read_work_buf, read_buf, *malloc_size, CODE_AUTO, global_param.client_language_code);

	debug_log_output("skin: nkf end." );

	// ワークエリアをfree.
	free(read_work_buf);


	return read_buf;	// 正常終了
}






// **************************************************************************
// *path で指定されたディレクトリに存在するファイル数をカウントする
//
// return: ファイル数
// **************************************************************************
static int count_file_num(unsigned char *path)
{
	int		count;

	DIR	*dir;
	struct dirent	*dent;

	debug_log_output("count_file_num() start. path='%s'", path);

	dir = opendir(path);
	if ( dir == NULL )	// エラーチェック
	{
		debug_log_output("opendir() error");
		return ( -1 );
	}

	count = 0;
	while ( 1 )
	{
		dent = readdir(dir);
		if ( dent == NULL  )
			break;

		// 無視ファイルチェック。
		if ( file_ignoral_check(dent->d_name, path) != 0 )
			continue;

		count++;
	}

	closedir(dir);

	debug_log_output("count_file_num() end. counter=%d", count);
	return count;
}



// **************************************************************************
// ディレクトリに存在する情報を、ファイルの数だけ読み込む。
//
// return: 読み込んだファイル情報数
// **************************************************************************
static int directory_stat(unsigned char *path, FILE_INFO_T *file_info_p, int file_num)
{
	int	count;
	DIR	*dir;
	struct dirent	*dent;
	struct stat		file_stat;
	int				result;
	unsigned char	fullpath_filename[FILENAME_MAX];
	unsigned char	file_extension[8];


	debug_log_output("directory_stat() start. path='%s'", path);


	dir = opendir(path);
	if ( dir == NULL )	// エラーチェック
	{
		debug_log_output("opendir() error");
		return ( -1 );
	}

	count = 0;
	while ( 1 )
	{
		if ( count >= file_num )
			break;

		// ディレクトリから、ファイル名を１個GET
		dent = readdir(dir);
		if ( dent == NULL  )
			break;

		// 無視ファイルチェック。
		if ( file_ignoral_check(dent->d_name, path) != 0 )
			continue;

		//debug_log_output("dent->d_name='%s'", dent->d_name);


		// フルパスファイル名生成
		strncpy(fullpath_filename, path, sizeof(fullpath_filename) );
		strncat(fullpath_filename, dent->d_name, sizeof(fullpath_filename) - strlen(fullpath_filename) );

		//debug_log_output("fullpath_filename='%s'", fullpath_filename );

		// stat() 実行
		memset(&file_stat, 0, sizeof(file_stat));
		result = stat(fullpath_filename, &file_stat);
		if ( result < 0 )
			continue;


		// 対象がディレクトリだった場合、SVIと同一名称ディレクトリチェック。
		if (( S_ISDIR( file_stat.st_mode ) != 0 ) && ( global_param.flag_hide_same_svi_name_directory == TRUE ))
		{
			// チェック実行
			if ( directory_same_check_svi_name(fullpath_filename) != 0 )
				continue;
		}

		// ファイル名を保存
		strncpy(file_info_p[count].org_name, dent->d_name, sizeof(file_info_p[count].org_name) );
		strncpy(file_info_p[count].name, dent->d_name, sizeof(file_info_p[count].name) );


		// 表示用ファイル名を、CAP/HEX 文字列変換
		if ( global_param.flag_decode_samba_hex_and_cap == TRUE )
		{
			debug_log_output("name(cap/hex) = '%s'", file_info_p[count].name);
			decode_samba_hex_and_cap_coding( file_info_p[count].name );
			debug_log_output("name(bin) = '%s'", file_info_p[count].name);
		}


		// その他情報を保存
		file_info_p[count].type = file_stat.st_mode;
		file_info_p[count].size = file_stat.st_size;
		file_info_p[count].time = file_stat.st_mtime;


		// SVIファイルだったら、file_info_p[count].size を入れ替える。
		filename_to_extension( fullpath_filename, file_extension, sizeof(file_extension));

		if ( strcasecmp(file_extension, "svi") ==  0 )
		{
			file_info_p[count].size = svi_file_total_size(fullpath_filename);
		}

		count++;
	}

	closedir(dir);

	debug_log_output("directory_stat() end. count=%d", count);

	return count;
}


// ******************************************************************
// ファイル無視チェック
// ディレクトリ内で、ファイルを、無視するかしないかを判断する。
// return: 0:OK  -1 無視
// ******************************************************************
static int file_ignoral_check( unsigned char *name, unsigned char *path )
{
	int				i;
	unsigned char	file_extension[16];
	char			flag;
	
	unsigned char	work_filename[FILENAME_MAX];
	struct stat		file_stat;
	int				result;

	// =====================================
	// "."と".."はスキップする。
	// =====================================
	if ( strcmp(name , ".") == 0 )
		return ( -1 );

	if ( strcmp(name , "..") == 0 )
		return ( -1 );

	// =====================================
	// "lost+found" もスキップ
	// =====================================
	if ( strcmp(name , "lost+found") == 0 )
		return ( -1 );

	// ==================================================================
	// MacOSX用 "._" で始まるファイルをスキップ（リソースファイル）
	// ==================================================================
	if ( strncmp(name, "._", 2 ) == 0 )
	{
		return ( -1 );
	}


	// ==================================================================
	// wizdが知らないファイル隠しフラグがたっていたら、拡張子チェック
	// ==================================================================
	if ( global_param.flag_unknown_extention_file_hide == TRUE ) 
	{
		filename_to_extension( name, file_extension, sizeof(file_extension) );

		if ( strlen(file_extension) > 0 ) // 拡張子無しはスキップ
		{
			flag = 0;
			for ( i=0; mime_list[i].file_extension != NULL; i++)
			{
				if ( strcasecmp(mime_list[i].file_extension, file_extension ) == 0 )
				{
					//debug_log_output("%s Known!!!", file_extension );
					flag = 1; // 知ってた
					break;
				}
			}

			if ( flag == 0 ) // 知らなかった。
			{
				// -----------------------------------------------
				// ファイルが、ホントにファイルかチェック。
				// もしもディレクトリなら、returnしない。
				// -----------------------------------------------

				// フルパス生成
				strncpy(work_filename, path, sizeof(work_filename) );
				if ( work_filename[strlen(work_filename)-1] != '/' )
				{
					strncat(work_filename, "/", sizeof(work_filename) - strlen(work_filename) );
				}
				strncat(work_filename, name, sizeof(work_filename) - strlen(work_filename) );


				debug_log_output("'%s' Unknown. directory check start.", work_filename );

				// stat() 実行
				result = stat(work_filename, &file_stat);
				if ( result != 0 )
					return ( -1 );

				if ( S_ISDIR(file_stat.st_mode) == 0 ) // ディレクトリじゃない。知らない拡張子ファイルだと確定。
				{
					debug_log_output("'%s' Unknown!!!", name );
					return ( -1 );
				}

				debug_log_output("'%s' is directory!!!", name );
			}
		}
	}


	// ==================================================================
	// 隠しディレクトリチェック
	// ==================================================================
	for ( i=0; i<SECRET_DIRECTORY_MAX; i++ )
	{
		if ( strcmp(name, secret_directory_list[i].dir_name ) == 0 )
		{
			debug_log_output("secret_directory_list[%d].'%s' HIT!!", i, secret_directory_list[i].dir_name);
			return ( -1 );
		}
	}


	return ( 0 );
}

// ******************************************************************
// SVIと同一名称ディレクトリチェック。
// return: 0:OK  -1 無視
// ******************************************************************
static int directory_same_check_svi_name( unsigned char *name )
{
	unsigned char	check_svi_filename[FILENAME_MAX];
	struct stat		svi_stat;
	int				result;

	debug_log_output("directory_same_check_svi_name() start.'%s'", name);

	// チェックするSVIファイル名生成
	strncpy( check_svi_filename, name, sizeof(check_svi_filename));
	strncat( check_svi_filename, ".svi", sizeof(check_svi_filename) - strlen(check_svi_filename) );

	result = stat(check_svi_filename, &svi_stat);
	if ( result >= 0 ) // あった？
	{
		debug_log_output("check_svi_filename '%s' found!!", check_svi_filename);
		return ( -1 );
	}

	return ( 0 );	// OK
}



// **************************************************************************
//
// HTTP_OKヘッダを生成して、メニュー画面返信実行
//
// **************************************************************************
static void http_filemenu_send(int accept_socket, unsigned char *filemenu_data)
{
	unsigned int	send_data_len;
	unsigned char	send_http_header_buf[1024];
	unsigned char	work_buf[1024];
	int	result_len;

	// --------------
	// OK ヘッダ生成
	// --------------
	memset(send_http_header_buf, '\0', sizeof(send_http_header_buf));

	strncpy(send_http_header_buf, HTTP_OK, sizeof(send_http_header_buf));
	strncat(send_http_header_buf, HTTP_CONNECTION, sizeof(send_http_header_buf) - strlen(send_http_header_buf) );
	snprintf(work_buf, sizeof(work_buf), HTTP_CONTENT_TYPE, "text/html");
	strncat(send_http_header_buf, work_buf, sizeof(send_http_header_buf) - strlen(send_http_header_buf));
	snprintf(work_buf, sizeof(work_buf), HTTP_SERVER_NAME, SERVER_NAME);
	strncat(send_http_header_buf, work_buf, sizeof(send_http_header_buf) - strlen(send_http_header_buf) );

	snprintf(work_buf, sizeof(work_buf), HTTP_CONTENT_LENGTH, (long long int)strlen(filemenu_data) );
	strncat(send_http_header_buf, work_buf, sizeof(send_http_header_buf) - strlen(send_http_header_buf) );

	strncat(send_http_header_buf, HTTP_END, sizeof(send_http_header_buf) - strlen(send_http_header_buf));


	send_data_len = strlen(send_http_header_buf);
	debug_log_output("header_send_data_len = %d\n", send_data_len);
	debug_log_output("--------\n");
	debug_log_output("%s", send_http_header_buf);
	debug_log_output("--------\n");


	// --------------
	// ヘッダ返信
	// --------------
	result_len = send(accept_socket, send_http_header_buf, send_data_len, 0);
	debug_log_output("result_len=%d, send_data_len=%d\n", result_len, send_data_len);


	// --------------
	// 実体返信
	// --------------
	send_data_len = strlen(filemenu_data);
	result_len = send(accept_socket, filemenu_data, send_data_len, 0);
	debug_log_output("result_len=%d, send_data_len=%d\n", result_len, send_data_len );

	return;
}




// **************************************************************************
// * allplay 用のプレイリストを生成
// **************************************************************************
static void create_all_play_list(HTTP_RECV_INFO *http_recv_info_p, FILE_INFO_T *file_info_p, int file_num, unsigned char *send_filemenu_buf, int buf_size)
{
	int		i,j;

	int		stream_type;
	unsigned char	file_extension[32];
	unsigned char	file_name[255];
	unsigned char	file_uri_link[FILENAME_MAX];

	unsigned char	work_data[FILENAME_MAX * 2];
	SKIN_REPLASE_LINE_DATA_T	mp3_id3tag_data;	// MP3 ID3タグ読み込み用

	debug_log_output("create_all_play_list() start.");

	memset(send_filemenu_buf, '\0', buf_size);

	// =================================
	// ファイル表示用情報 生成開始
	// =================================
	for ( i=0; i<file_num ; i++ )
	{
		// 拡張子だけ生成
		filename_to_extension(file_info_p[i].org_name, file_extension, sizeof(file_extension));
		debug_log_output("file_extension='%s'\n", file_extension);

		// ---------------------------------------------------------
		// ファイルタイプ判定。STREAMファイル以外ならcontinue.
		// ---------------------------------------------------------

		// ディレクトリか？
		if ( S_ISDIR( file_info_p[i].type ) != 0 )
		{
			continue;
		}

		// 拡張子からストリームタイプを判断。
		stream_type = TYPE_NO_STREAM;
		for (j=0;;j++)
		{
			if (( mime_list[j].mime_name == NULL ) || ( strlen(file_extension) == 0 ) )
				break;

			if ( strcasecmp(mime_list[j].file_extension, file_extension) == 0 )
			{
				stream_type = mime_list[j].stream_type;
				break;
			}
		}


		// ------------------------------------------------------
		// ストリームファイル以外ならcontinue
		// ------------------------------------------------------
		if ( stream_type != TYPE_STREAM )
		{
			continue;
		}



		// -----------------------------------------
		// 拡張子がmp3なら、ID3タグチェック。
		// -----------------------------------------
		mp3_id3tag_data.mp3_id3v1_flag = 0;

		if ( strcasecmp(file_extension, "mp3" ) == 0 )
		{
			// MP3ファイルのフルパス生成
			strncpy( work_data, http_recv_info_p->send_filename, sizeof(work_data));
			if ( work_data[strlen(work_data)-1] != '/' )
			{
				strncat(work_data, "/", sizeof(work_data) - strlen(work_data) );
			}
			strncat(work_data, file_info_p[i].org_name, sizeof(work_data) - strlen(work_data));
			debug_log_output("work_data(mp3) = %s", work_data);

			// ID3タグチェック
			memset( &mp3_id3tag_data, 0, sizeof(mp3_id3tag_data));
			mp3_id3v1_tag_read(work_data , &mp3_id3tag_data );
		}


		// MP3 ID3タグが存在したならば、playlist 表示ファイル名をID3タグで置き換える。
		if ( mp3_id3tag_data.mp3_id3v1_flag == 1 )
		{
			strncpy(work_data, mp3_id3tag_data.mp3_id3v1_title_info, sizeof(work_data));
			strncat(work_data, ".mp3", sizeof(work_data) - strlen(work_data));	// ダミーの拡張子。playlist_filename_adjustment()で削除される。

			// =========================================
			// playlist表示用 ID3タグを調整
			// EUCに変換 → 拡張子削除 → (必要なら)半角文字を全角に変換 → MediaWizコードに変換 → SJISなら、不正文字コード0x7C('|')を含む文字を削除。
			// =========================================
			playlist_filename_adjustment( work_data, file_name, sizeof(file_name), CODE_AUTO );
		}
		else
		// MP3 ID3タグが存在しないならば、ファイル名をそのまま使用する。
		{
			// ---------------------------------
			// 表示ファイル名 調整
			// EUCに変換 → 拡張子削除 → (必要なら)半角文字を全角に変換 → MediaWizコードに変換 → SJISなら、不正文字コード0x7C('|')を含む文字を削除。
			// ---------------------------------
			playlist_filename_adjustment(file_info_p[i].name, file_name, sizeof(file_name), global_param.server_language_code);
		}

		// ------------------------------------
		// Link用URI(エンコード済み) を生成
		// ------------------------------------
		strncpy(work_data, http_recv_info_p->recv_uri, sizeof(work_data) );
		strncat(work_data, file_info_p[i].org_name, sizeof(work_data)- strlen(work_data) );
	 	uri_encode(file_uri_link, sizeof(file_uri_link), work_data, strlen(work_data) );

		debug_log_output("file_uri_link='%s'\n", file_uri_link);

		// URIの拡張子置き換え処理。
		extension_add_rename(file_uri_link);


		// ------------------------------------
		// プレイリストを生成
		// ------------------------------------
		strncpy(work_data, file_name, sizeof(work_data));
		strncat(work_data, "|0|0|http://", sizeof(work_data) - strlen(work_data) );
		strncat(work_data, http_recv_info_p->recv_host, sizeof(work_data) - strlen(work_data) );
		strncat(work_data, file_uri_link, sizeof(work_data) - strlen(work_data) );
		strncat(work_data, "|\r\n", sizeof(work_data) - strlen(work_data) );

		debug_log_output("work_data='%s'", work_data);

		// ------------------------------------
		// 送信バッファに追加
		// ------------------------------------
		strncat(send_filemenu_buf, work_data, buf_size - strlen(send_filemenu_buf) );

	}

	return;
}




// *************************************************************************
//  表示ファイルソート
// *************************************************************************
static void file_info_sort( FILE_INFO_T *p, int num, unsigned long type )
{


	int nDir, nFile, i, row;

	// ディレクトリ数とファイル数の分離
	for ( nDir = 0, i = 0; i < num; ++i )
	{
		if ( S_ISDIR( p[ i ].type ) )
		{
			++nDir;
		}
	}
	nFile = num - nDir;

	// ソート処理 ******************************************************************
	// 準備
	row = 0;

	// ディレクトリソートがあれば行う
	if ( SORT_DIR_FLAG( type ) && nDir > 0 )
	{
		// とりあえず全部ソート
		qsort( p, num, sizeof( FILE_INFO_T ), dir_sort_api[ SORT_DIR_FLAG( type ) ] );

		// ディレクトリ名のソート
		qsort( &p[ ( SORT_DIR_FLAG( type ) == SORT_DIR_DOWN ) ? num - nDir : 0 ], nDir, sizeof( FILE_INFO_T ), file_sort_api[ SORT_NAME_UP ] );

		// ファイル位置確定
		row = ( SORT_DIR_FLAG( type ) == SORT_DIR_DOWN ) ? 0 : nDir;
	}
	else
	{
		// ファイルソート対象を全件にする
		nFile = num;
	}

	// ファイルソートを行う
	// ディレクトリが対象になっていなければ、全件対象にする
	if ( ( type & SORT_FILE_MASK ) && nFile > 0 )
	{
		qsort( &p[ row ], nFile, sizeof( FILE_INFO_T ), file_sort_api[ ( type & SORT_FILE_MASK ) ] );
	}

	return;
}



// *************************************************************************
// ディレクトリのソート
// *************************************************************************
static int _file_info_dir_sort( const void *in_a, const void *in_b, int order )
{
	FILE_INFO_T *a, *b;
	int n1, n2;

	a = (FILE_INFO_T *) in_a;
	b = (FILE_INFO_T *) in_b;
	n1 = ( S_ISDIR( a->type ) ? 1 : 0 );
	n2 = ( S_ISDIR( b->type ) ? 1 : 0 );
	return ( n1 == n2 ? 0 : ( order ? n1 - n2 : n2 - n1 ) );
}
static int _file_info_dir_sort_order_up( const void *in_a, const void *in_b )
{
	return _file_info_dir_sort( in_a, in_b, 0 );
}
static int _file_info_dir_sort_order_down( const void *in_a, const void *in_b )
{
	return _file_info_dir_sort( in_a, in_b, 1 );
}




// *************************************************************************
// 名前のソート
// *************************************************************************
static int _file_info_name_sort( const void *in_a, const void *in_b, int order )
{
	FILE_INFO_T *a, *b;

	a = (FILE_INFO_T *) in_a;
	b = (FILE_INFO_T *) in_b;
	return ( order ? strcmp( b->name, a->name ) : strcmp( a->name, b->name ) );
}
static int _file_info_name_sort_order_up( const void *in_a, const void *in_b )
{
	return _file_info_name_sort( in_a, in_b, 0 );
}
static int _file_info_name_sort_order_down( const void *in_a, const void *in_b )
{
	return _file_info_name_sort( in_a, in_b, 1 );
}




// *************************************************************************
// サイズのソート
// *************************************************************************
static int _file_info_size_sort( const void *in_a, const void *in_b, int order )
{
	FILE_INFO_T *a, *b;

	a = (FILE_INFO_T *) in_a;
	b = (FILE_INFO_T *) in_b;
	return (int)( order ? b->size - a->size : a->size - b->size );
}
static int _file_info_size_sort_order_up( const void *in_a, const void *in_b )
{
	return _file_info_size_sort( in_a, in_b, 0 );
}
static int _file_info_size_sort_order_down( const void *in_a, const void *in_b )
{
	return _file_info_size_sort( in_a, in_b, 1 );
}



// *************************************************************************
// 時間のソート
// *************************************************************************
static int _file_info_time_sort( const void *in_a, const void *in_b, int order )
{
	FILE_INFO_T *a, *b;

	a = (FILE_INFO_T *) in_a;
	b = (FILE_INFO_T *) in_b;
	return (int)( order ? b->time - a->time : a->time - b->time );
}
static int _file_info_time_sort_order_up( const void *in_a, const void *in_b )
{
	return _file_info_time_sort( in_a, in_b, 0 );
}
static int _file_info_time_sort_order_down( const void *in_a, const void *in_b )
{
	return _file_info_time_sort( in_a, in_b, 1 );
}








#define		SKIN_IMAGE_VIEWER_HTML 	"image_viewer.html"	// ImageViewerのスキン

#define		SKIN_KEYWORD_IMAGE_VIEWER_WIDTH		"<!--WIZD_INSERT_IMAGE_VIEWER_WIDTH-->"		// ImageViewerの表示横幅
#define		SKIN_KEYWORD_IMAGE_VIEWER_HEIGHT	"<!--WIZD_INSERT_IMAGE_VIEWER_HEIGHT-->"	// ImageViewerの表示高さ
#define		SKIN_KEYWORD_IMAGE_VIEWER_MODE		"<!--WIZD_INSERT_IMAGE_VIEWER_MODE-->"		// ImageViewerの現在のモード



// FITモードの時、以下の範囲を削除
#define		SKIN_KEYWORD_DEL_IS_FIT_MODE	"<!--WIZD_DELETE_IS_FIT_MODE-->"
#define		SKIN_KEYWORD_DEL_IS_FIT_MODE_E	"<!--/WIZD_DELETE_IS_FIT_MODE-->"


// FITモード以外の時、以下の範囲を削除
#define		SKIN_KEYWORD_DEL_IS_NO_FIT_MODE		"<!--WIZD_DELETE_IS_NO_FIT_MODE-->"
#define		SKIN_KEYWORD_DEL_IS_NO_FIT_MODE_E	"<!--/WIZD_DELETE_IS_NO_FIT_MODE-->"


#define		FIT_TERGET_WIDTH	(533)
#define		FIT_TERGET_HEIGHT	(400)


// **************************************************************************
// * イメージビューアーを生成して返信
// **************************************************************************
void http_image_viewer(int accept_socket, HTTP_RECV_INFO *http_recv_info_p)
{
	unsigned char	*image_viewer_skin_p;
	int				image_viewer_skin_malloc_size;
	unsigned int 	image_width, image_height;
	unsigned int 	image_viewer_width, image_viewer_height;

	unsigned char	file_extension[32];

	unsigned char	skin_filename[FILENAME_MAX];
	unsigned char	work_data[FILENAME_MAX];

	struct	stat	image_stat;
	int		result;
	int		now_page;

	int		flag_fit_mode = 0;

	SKIN_REPLASE_IMAGE_VIEWER_DATA_T	image_viewer_info;


	// ========================
	// 置換用データ生成
	// ========================
	// 一つ上のディレクトリパス(親パス)を生成。(URIエンコード)
	strncpy(work_data, http_recv_info_p->recv_uri, sizeof(work_data) - strlen(work_data) );
	cut_after_last_character(work_data, '/');
	strncat(work_data, "/", sizeof(work_data) - strlen(work_data) ); // 最後に'/'を追加。
	debug_log_output("parent_directory='%s'", work_data);


 	uri_encode(image_viewer_info.parent_directory_link, sizeof(image_viewer_info.parent_directory_link), work_data, strlen(work_data));
	strncat(image_viewer_info.parent_directory_link, "?", sizeof(image_viewer_info.parent_directory_link) - strlen(image_viewer_info.parent_directory_link));
	// sort=が指示されていた場合、それを引き継ぐ。
	if ( strlen(http_recv_info_p->sort) > 0 )
	{
		snprintf(work_data, sizeof(work_data), "sort=%s&", http_recv_info_p->sort);
		strncat(image_viewer_info.parent_directory_link, work_data, sizeof(image_viewer_info.parent_directory_link) - strlen(image_viewer_info.parent_directory_link));
	}
	debug_log_output("parent_directory_link='%s'", image_viewer_info.parent_directory_link);


	// 現パス名 表示用 生成(文字コード変換)
	convert_language_code(	http_recv_info_p->recv_uri,
							image_viewer_info.current_uri_name,
							sizeof(image_viewer_info.current_uri_name),
							global_param.server_language_code,
							global_param.client_language_code);
	debug_log_output("image_viewer: current_uri = '%s'", image_viewer_info.current_uri_name );

	// 現パス名 Link用生成（URIエンコード）
 	uri_encode(image_viewer_info.current_uri_link, sizeof(image_viewer_info.current_uri_link), http_recv_info_p->recv_uri, strlen(http_recv_info_p->recv_uri));
	strncat(image_viewer_info.current_uri_link, "?", sizeof(image_viewer_info.current_uri_link) - strlen(image_viewer_info.current_uri_link)); // 最後に'?'を追加
	// sort=が指示されていた場合、それを引き継ぐ。
	if ( strlen(http_recv_info_p->sort) > 0 )
	{
		snprintf(work_data, sizeof(work_data), "sort=%s&", http_recv_info_p->sort);
		strncat(image_viewer_info.current_uri_link, work_data, sizeof(image_viewer_info.current_uri_link) - strlen(image_viewer_info.current_uri_link));
	}
	debug_log_output("image_viewer: current_uri_link='%s'", image_viewer_info.current_uri_link);





	if ( http_recv_info_p->page <= 1 )
		now_page = 1;
	else
		now_page = http_recv_info_p->page;


	// 	現在のページ 表示用
	snprintf(image_viewer_info.now_page_str, sizeof(image_viewer_info.now_page_str), "%d", now_page );


	// ファイルサイズ, タイムスタンプGET
	result = stat(http_recv_info_p->send_filename, &image_stat);
	if ( result != 0 )
	{
		debug_log_output("stat(%s) error.", http_recv_info_p->send_filename);
		return;
	}

	conv_num_to_unit_string(image_viewer_info.file_size_string, image_stat.st_size );
	conv_time_to_string(image_viewer_info.file_timestamp, image_stat.st_mtime );
	conv_time_to_date_string(image_viewer_info.file_timestamp_date, image_stat.st_mtime );
	conv_time_to_time_string(image_viewer_info.file_timestamp_time, image_stat.st_mtime );


	// 画像サイズGET
	image_width = 0;
	image_height = 0;

	// 拡張子取り出し
	filename_to_extension(http_recv_info_p->send_filename, file_extension, sizeof(file_extension) );

	// 拡張子で分岐
	if ( (strcasecmp( file_extension, "jpg" ) == 0 ) ||
		 (strcasecmp( file_extension, "jpeg" ) == 0 ))
	{
		// JPEGファイルのサイズをGET
		jpeg_size( http_recv_info_p->send_filename, &image_width, &image_height );
	}
	else if (strcasecmp( file_extension, "gif" ) == 0 )
	{
		// GIFファイルのサイズをGET
		gif_size( http_recv_info_p->send_filename, &image_width, &image_height );
	}
	else if (strcasecmp( file_extension, "png" ) == 0 )
	{
		// PNGファイルのサイズをGET
		png_size( http_recv_info_p->send_filename, &image_width, &image_height );
	}
	debug_log_output("image_width=%d, image_height=%d", image_width, image_height);

	snprintf(image_viewer_info.image_width, sizeof(image_viewer_info.image_width), "%d", image_width);
	snprintf(image_viewer_info.image_height, sizeof(image_viewer_info.image_height), "%d", image_height);



	// 表示サイズ（仮）
	if ( strcasecmp(http_recv_info_p->option, "-2" ) == 0 )  // 0.5x
	{
		image_viewer_width = image_width / 2;
		image_viewer_height = image_height / 2;
		strncpy(image_viewer_info.image_viewer_mode, "0.5x", sizeof(image_viewer_info.image_viewer_mode) );
	}
	else if ( strcasecmp(http_recv_info_p->option, "2x" ) == 0 )  // 2x
	{
		image_viewer_width = image_width * 2;
		image_viewer_height = image_height * 2 ;
		strncpy(image_viewer_info.image_viewer_mode, "2x", sizeof(image_viewer_info.image_viewer_mode) );
	}
	else if ( strcasecmp(http_recv_info_p->option, "4x" ) == 0 )  // 4x
	{
		image_viewer_width = image_width * 4;
		image_viewer_height = image_height * 4 ;
		strncpy(image_viewer_info.image_viewer_mode, "4x", sizeof(image_viewer_info.image_viewer_mode) );
	}
	else if ( strcasecmp(http_recv_info_p->option, "fit" ) == 0 )  // FIT
	{
		// 縦に合わせてリサイズしてみる
		image_viewer_width = (image_width  * FIT_TERGET_HEIGHT) / image_height;
		image_viewer_height = FIT_TERGET_HEIGHT;

		if ( image_viewer_width > FIT_TERGET_WIDTH ) // 横幅超えていたら
		{
			// 横に合わせてリサイズする。
			image_viewer_width = FIT_TERGET_WIDTH;
			image_viewer_height = image_height * FIT_TERGET_WIDTH / image_width;
		}

		debug_log_output("fit:  (%d,%d) -> (%d,%d)", image_width, image_height, image_viewer_width, image_viewer_height);


		strncpy(image_viewer_info.image_viewer_mode, "FIT", sizeof(image_viewer_info.image_viewer_mode) );

		flag_fit_mode = 1;
	}
	else	// 1x
	{
		image_viewer_width = image_width;
		image_viewer_height = image_height;
		strncpy(image_viewer_info.image_viewer_mode, "1x", sizeof(image_viewer_info.image_viewer_mode) );
	}

	snprintf(image_viewer_info.image_viewer_width, sizeof(image_viewer_info.image_viewer_width), "%d", image_viewer_width );
	snprintf(image_viewer_info.image_viewer_height, sizeof(image_viewer_info.image_viewer_height), "%d", image_viewer_height );


	// ==============================
	// ImageViewer スキン読み込み
	// ==============================

	// ----------------------------------------------
	// スキンのフルパス生成
	// スキンのあるファイルパス生成
	// ----------------------------------------------
	strncpy(skin_filename, global_param.skin_root, sizeof(skin_filename) ); // スキン置き場
	if ( skin_filename[ strlen(skin_filename)-1 ] != '/' )// 最後が'/'じゃなかったら、'/'を追加
	{
		strncat(skin_filename, "/", sizeof(skin_filename) -strlen(skin_filename) );
	}

	strncat(skin_filename, global_param.skin_name, sizeof(skin_filename) - strlen(skin_filename) ); // スキン名（ディレクトリ）
	if ( skin_filename[ strlen(skin_filename)-1 ] != '/' ) // 最後が'/'じゃなかったら、'/'を追加
	{
		strncat(skin_filename, "/", sizeof(skin_filename) - strlen(skin_filename) );
	}

	// ImageView スキンファイル名生成
	strncat(skin_filename, SKIN_IMAGE_VIEWER_HTML, sizeof(skin_filename) - strlen(skin_filename) );
	debug_log_output("skin: skin_filename='%s'", skin_filename);

	// スキンデータ読み込み
	image_viewer_skin_p = skin_file_read( skin_filename, &image_viewer_skin_malloc_size);


	// ==============================
	// 置換実行
	// ==============================


	// SERVER_NAME
	replase_character(image_viewer_skin_p, image_viewer_skin_malloc_size, SKIN_KEYWORD_SERVER_NAME, SERVER_NAME);

	// CURRENT_PATH 現在のパス（表示用）
	replase_character(image_viewer_skin_p, image_viewer_skin_malloc_size, SKIN_KEYWORD_CURRENT_PATH, image_viewer_info.current_uri_name);

	// CURRENT_PATH_LINK	現在のパス（LINK用 URIエンコード）
	replase_character(image_viewer_skin_p, image_viewer_skin_malloc_size, SKIN_KEYWORD_CURRENT_PATH_LINK, image_viewer_info.current_uri_link);

	// SKIN_KEYWORKD_PARLENT_DIR_LINK 	親ディレクトリ(LINK用 URIエンコード)
	replase_character(image_viewer_skin_p, image_viewer_skin_malloc_size, SKIN_KEYWORKD_PARLENT_DIR_LINK, image_viewer_info.parent_directory_link );

	// SKIN_KEYWORD_CURRENT_PAGE	 	現在のページ
	replase_character(image_viewer_skin_p, image_viewer_skin_malloc_size, SKIN_KEYWORD_CURRENT_PAGE, image_viewer_info.now_page_str);


	// SKIN_KEYWORD_LINE_TIMESTAMP	  日時 表示用
	replase_character(image_viewer_skin_p, image_viewer_skin_malloc_size, SKIN_KEYWORD_LINE_TIMESTAMP, image_viewer_info.file_timestamp );

	// SKIN_KEYWORD_LINE_FILE_DATE	  日付 表示用
	replase_character(image_viewer_skin_p, image_viewer_skin_malloc_size, SKIN_KEYWORD_LINE_FILE_DATE, image_viewer_info.file_timestamp_date );

	// SKIN_KEYWORD_LINE_FILE_TIME	  時刻 表示用
	replase_character(image_viewer_skin_p, image_viewer_skin_malloc_size, SKIN_KEYWORD_LINE_FILE_TIME, image_viewer_info.file_timestamp_time );



	// SKIN_KEYWORD_LINE_FILE_SIZE	ファイルサイズ 表示用
	replase_character(image_viewer_skin_p, image_viewer_skin_malloc_size, SKIN_KEYWORD_LINE_FILE_SIZE,  image_viewer_info.file_size_string );


	// SKIN_KEYWORD_LINE_IMAGE_WIDTH	// 画像の横幅
	replase_character(image_viewer_skin_p, image_viewer_skin_malloc_size, SKIN_KEYWORD_LINE_IMAGE_WIDTH,  image_viewer_info.image_width );

	// SKIN_KEYWORD_LINE_IMAGE_HEIGHT	// 画像の高さ
	replase_character(image_viewer_skin_p, image_viewer_skin_malloc_size, SKIN_KEYWORD_LINE_IMAGE_HEIGHT,  image_viewer_info.image_height );




	// SKIN_KEYWORD_IMAGE_VIEWER_WIDTH		// 画像の表示横幅
	replase_character(image_viewer_skin_p, image_viewer_skin_malloc_size, SKIN_KEYWORD_IMAGE_VIEWER_WIDTH,  image_viewer_info.image_viewer_width );

	// SKIN_KEYWORD_IMAGE_VIEWER_HEIGHT		// 画像の表示高さ
	replase_character(image_viewer_skin_p, image_viewer_skin_malloc_size, SKIN_KEYWORD_IMAGE_VIEWER_HEIGHT,  image_viewer_info.image_viewer_height );

	// SKIN_KEYWORD_IMAGE_VIEWER_MODE		// 画像表示モード
	replase_character(image_viewer_skin_p, image_viewer_skin_malloc_size, SKIN_KEYWORD_IMAGE_VIEWER_MODE,  image_viewer_info.image_viewer_mode );

	// FITモードチェック
	if ( flag_fit_mode == 0 ) // FITモードではない
	{
		cut_enclose_words(image_viewer_skin_p, image_viewer_skin_malloc_size, SKIN_KEYWORD_DEL_IS_NO_FIT_MODE, SKIN_KEYWORD_DEL_IS_NO_FIT_MODE_E);
	}
	else // FITモード
	{
		cut_enclose_words(image_viewer_skin_p, image_viewer_skin_malloc_size, SKIN_KEYWORD_DEL_IS_FIT_MODE, SKIN_KEYWORD_DEL_IS_FIT_MODE_E);
	}


	debug_log_output("response: %s", image_viewer_skin_p);

	// =================
	// 返信実行
	// =================
	http_filemenu_send( accept_socket, image_viewer_skin_p );


	free(image_viewer_skin_p);

	return;
}

// **************************************************************************
// * Single Play Listを生成して返信
// **************************************************************************
void http_music_single_play(int accept_socket, HTTP_RECV_INFO *http_recv_info_p)
{
	unsigned char	work_data[FILENAME_MAX*2];

	unsigned char	file_name[FILENAME_MAX];
	unsigned char	file_extension[16];
	unsigned char	file_uri_link[FILENAME_MAX];

	SKIN_REPLASE_LINE_DATA_T	mp3_id3tag_data;	// MP3 ID3タグ読み込み用


	// =========================================
	// URIからファイル名を取り出す。
	// =========================================
	strncpy( work_data, http_recv_info_p->recv_uri, sizeof(work_data) );
	cut_before_last_character(work_data, '/');

	debug_log_output("file_name:'%s'", work_data);
	filename_to_extension(work_data, file_extension, sizeof(file_extension));



	// =========================================
	// 拡張子がmp3なら、ID3タグチェック。
	// =========================================
	mp3_id3tag_data.mp3_id3v1_flag = 0;

	if ( strcasecmp(file_extension, "mp3" ) == 0 )
	{
		// ID3タグチェック
		memset( &mp3_id3tag_data, 0, sizeof(mp3_id3tag_data));
		mp3_id3v1_tag_read( http_recv_info_p->send_filename, &mp3_id3tag_data );
	}

	// MP3 ID3タグが存在したならば、playlist 表示ファイル名をID3タグで置き換える。
	if ( mp3_id3tag_data.mp3_id3v1_flag == 1 )
	{
		strncpy(work_data, mp3_id3tag_data.mp3_id3v1_title_info, 	sizeof(work_data));
		strncat(work_data, ".mp3" ,sizeof(work_data) - strlen(work_data));	// ダミーの拡張子。playlist_filename_adjustment()で削除される。

		// =========================================
		// playlist表示用 ID3タグを調整
		// EUCに変換 → 拡張子削除 → (必要なら)半角文字を全角に変換 → MediaWizコードに変換 → SJISなら、不正文字コード0x7C('|')を含む文字を削除。
		// =========================================
		playlist_filename_adjustment( work_data, file_name, sizeof(file_name), CODE_AUTO );

	}
	else 
	{
		// =========================================
		// playlist表示用ファイル名 を調整
		// EUCに変換 → 拡張子削除 → (必要なら)半角文字を全角に変換 → MediaWizコードに変換 → SJISなら、不正文字コード0x7C('|')を含む文字を削除。
		// =========================================
		playlist_filename_adjustment( work_data, file_name, sizeof(file_name), global_param.server_language_code );
	}

	debug_log_output("file_name(adjustment):'%s'", file_name );


	// =========================================
	// Link用URI(エンコード済み) を生成
	// =========================================
	strncpy(work_data, http_recv_info_p->recv_uri, sizeof(work_data) );
	uri_encode(file_uri_link, sizeof(file_uri_link), work_data, strlen(work_data) );
	debug_log_output("file_uri_link='%s'\n", file_uri_link);

	// URIの拡張子置き換え処理。
	extension_add_rename(file_uri_link);


	// =========================================
	// プレイリストを生成
	// =========================================
	strncpy(work_data, file_name, sizeof(work_data));
	strncat(work_data, "|0|0|http://", sizeof(work_data) - strlen(work_data) );
	strncat(work_data, http_recv_info_p->recv_host, sizeof(work_data) - strlen(work_data) );
	strncat(work_data, file_uri_link, sizeof(work_data) - strlen(work_data) );
	strncat(work_data, "|\r\n", sizeof(work_data) - strlen(work_data) );

	debug_log_output("work_data='%s'", work_data);


	// =================
	// 返信実行
	// =================
	http_filemenu_send( accept_socket, work_data );


	return;
}



// **************************************************************************
// * wizd play listファイル(*.plw)より、PlayListを生成して返信
// **************************************************************************
void http_listfile_to_playlist_create(int accept_socket, HTTP_RECV_INFO *http_recv_info_p)
{
	unsigned char *playlist_buf_malloc_p;

	int		fd;
	int		ret;

	unsigned char	buf[FILENAME_MAX];

	unsigned char	listfile_path[FILENAME_MAX];

	unsigned char	file_extension[32];
	unsigned char	file_name[255];
	unsigned char	file_uri_link[FILENAME_MAX];

	unsigned char	work_data[FILENAME_MAX *2];
	SKIN_REPLASE_LINE_DATA_T	mp3_id3tag_data;	// MP3 ID3タグ読み込み用



	// plwデータ、open
	fd = open(http_recv_info_p->send_filename, O_RDONLY);
	if ( fd < 0 )
	{
		debug_log_output("'%s' can't open.", http_recv_info_p->send_filename);
		return;
	}


	// listfileがあるパスを生成
	strncpy( listfile_path, http_recv_info_p->recv_uri, sizeof(listfile_path));
	cut_after_last_character( listfile_path, '/' );
	if ( listfile_path[strlen(listfile_path)-1] != '/' )
	{
		strncat( listfile_path, "/", sizeof(listfile_path) );
	}

	debug_log_output( "listfile_path: '%s'", listfile_path );


	// =============================
	// 返信データ生成領域をmalloc
	// =============================
	playlist_buf_malloc_p = malloc( FILEMENU_BUF_SIZE );
	if (playlist_buf_malloc_p == NULL)
	{
		debug_log_output("malloc() error");
		return;
	}

	memset( playlist_buf_malloc_p, '\0', FILEMENU_BUF_SIZE );


	//=====================================
	// プレイリスト 生成開始
	//=====================================
	while ( 1 )
	{
		// ファイルから、１行読む
		ret = file_read_line( fd, buf, sizeof(buf) );
		if ( ret < 0 )
		{
			debug_log_output("listfile EOF Detect.");
			break;
		}

		debug_log_output("-------------");
		debug_log_output("read_buf:'%s'", buf);


		// コメント削除
		if ( buf[0] == '#' )
		{
			buf[0] = '\0';
		}

		// 行末のスペースを削除。
		cut_character_at_linetail(buf, ' ');

		debug_log_output("read_buf(comment cut):'%s'", buf);

		// 空行なら、continue
		if ( strlen( buf ) == 0 )
		{
			debug_log_output("continue.");
			continue;
		}


		// 拡張子 生成
		filename_to_extension(buf, file_extension, sizeof(file_extension) );
		debug_log_output("file_extension:'%s'", file_extension);

		// 表示ファイル名 生成
		strncpy(work_data, buf, sizeof(work_data));
		cut_before_last_character( work_data, '/' );
		strncpy( file_name, work_data, sizeof(file_name));
		debug_log_output("file_name:'%s'", file_name);


		// URI生成
		if ( buf[0] == '/' ) // 絶対パス
		{
			strncpy( file_uri_link, buf, sizeof(file_uri_link) );
		}
		else // 相対パス
		{
			strncpy( file_uri_link, listfile_path, sizeof(file_uri_link) );
			strncat( file_uri_link, buf, sizeof(file_uri_link) - strlen(file_uri_link) );
		}

		debug_log_output("listfile_path:'%s'", listfile_path);
		debug_log_output("file_uri_link:'%s'", file_uri_link);


		// -----------------------------------------
		// 拡張子がmp3なら、ID3タグチェック。
		// -----------------------------------------
		mp3_id3tag_data.mp3_id3v1_flag = 0;
		if ( strcasecmp(file_extension, "mp3" ) == 0 )
		{
			// MP3ファイルのフルパス生成
			strncpy(work_data, global_param.document_root, sizeof(work_data) );
			if ( work_data[strlen(work_data)-1] == '/' )
				work_data[strlen(work_data)-1] = '\0';
			strncat( work_data, file_uri_link, sizeof(work_data) );

			debug_log_output("full_path(mp3):'%s'", work_data); // フルパス

			// ID3タグチェック
			memset( &mp3_id3tag_data, 0, sizeof(mp3_id3tag_data));
			mp3_id3v1_tag_read(work_data , &mp3_id3tag_data );
		}


		// MP3 ID3タグが存在したならば、playlist 表示ファイル名をID3タグで置き換える。
		if ( mp3_id3tag_data.mp3_id3v1_flag == 1 )
		{
			strncpy(work_data, mp3_id3tag_data.mp3_id3v1_title_info, sizeof(work_data));
			strncat(work_data, ".mp3", sizeof(work_data) - strlen(work_data));	// ダミーの拡張子。playlist_filename_adjustment()で削除される。

			// =========================================
			// playlist表示用 ID3タグを調整
			// EUCに変換 → 拡張子削除 → (必要なら)半角文字を全角に変換 → MediaWizコードに変換 → SJISなら、不正文字コード0x7C('|')を含む文字を削除。
			// =========================================
			playlist_filename_adjustment( work_data, file_name, sizeof(file_name), CODE_AUTO );
		}
		else
		// MP3 ID3タグが存在しないならば、ファイル名をそのまま使用する。
		{
			// ---------------------------------
			// 表示ファイル名 調整
			// EUCに変換 → 拡張子削除 → (必要なら)半角文字を全角に変換 → MediaWizコードに変換 → SJISなら、不正文字コード0x7C('|')を含む文字を削除。
			// ---------------------------------
			strncpy( work_data, file_name, sizeof(work_data) );
			playlist_filename_adjustment(work_data, file_name, sizeof(file_name), global_param.server_language_code);
		}

		debug_log_output("file_name(adjust):'%s'", file_name);

		// ------------------------------------
		// Link用URI(エンコード済み) を生成
		// ------------------------------------
		strncpy(work_data, file_uri_link, sizeof(work_data) );
	 	uri_encode(file_uri_link, sizeof(file_uri_link), work_data, strlen(work_data) );

		debug_log_output("file_uri_link(encoded):'%s'", file_uri_link);

		// URIの拡張子置き換え処理。
		extension_add_rename(file_uri_link);


		// ------------------------------------
		// プレイリストを生成
		// ------------------------------------
		strncpy(work_data, file_name, sizeof(work_data));
		strncat(work_data, "|0|0|http://", sizeof(work_data) - strlen(work_data) );
		strncat(work_data, http_recv_info_p->recv_host, sizeof(work_data) - strlen(work_data) );
		strncat(work_data, file_uri_link, sizeof(work_data) - strlen(work_data) );
		strncat(work_data, "|\r\n", sizeof(work_data) - strlen(work_data) );

		debug_log_output("work_data='%s'", work_data);

		// ------------------------------------
		// 送信バッファに追加
		// ------------------------------------
		strncat(playlist_buf_malloc_p, work_data,  FILEMENU_BUF_SIZE - strlen(playlist_buf_malloc_p) );

	}


	// =================
	// 返信実行
	// =================
	http_filemenu_send( accept_socket, playlist_buf_malloc_p );

	close( fd );
	free( playlist_buf_malloc_p );
	return;
}

// *****************************************************
// fd から１行読み込む
// 読み込んだ文字数がreturnされる。
// 最後まで読んだら、-1が戻る。
// *****************************************************
static int file_read_line( int fd, unsigned char *line_buf, int line_buf_size)
{
	int read_len;
	int	total_read_len;
	unsigned char	read_char;
	unsigned char *p;

	p = line_buf;
	total_read_len = 0;

	while ( 1 ) 
	{
		// 一文字read.
		read_len  = read(fd, &read_char, 1);
		if ( read_len <= 0 ) // EOF検知
		{
			return ( -1 );
		}
		else if ( read_char == '\r' )
		{
			continue;
		}
		else if ( read_char == '\n' )
		{
			break;
		}

		*p = read_char;
		p++;
		total_read_len++;

		if ( total_read_len >= line_buf_size )
		{
			break;
		}
	}

	*p = '\0';
	return total_read_len;
}


#define		SKIN_OPTION_MENU_HTML 	"option_menu.html"	// OptionMenuのスキン
#define		SKIN_KEYWORD_CURRENT_PATH_LINK_NO_SORT	"<!--WIZD_INSERT_CURRENT_PATH_LINK_NO_SORT-->"	// 現PATH(Sort情報引き継ぎ無し)。LINK用。URIエンコード済み

// **************************************************************************
// * オプションメニューを生成して返信
// **************************************************************************
void http_option_menu(int accept_socket, HTTP_RECV_INFO *http_recv_info_p)
{
	unsigned char	*option_menu_skin_p;
	int				option_menu_skin_malloc_size;


	unsigned char	current_uri_link_no_sort[FILENAME_MAX];
	unsigned char	current_uri_link[FILENAME_MAX];
	unsigned char	work_data[FILENAME_MAX];

	int				now_page;
	unsigned char	now_page_str[16];
	unsigned char	skin_filename[FILENAME_MAX];

	// ========================
	// 置換用データ生成
	// ========================

	// --------------------------------------------------------------
	// 現パス名 Link用(Sort情報引き継ぎ無し)生成（URIエンコード）
	// --------------------------------------------------------------
 	uri_encode(current_uri_link_no_sort, sizeof(current_uri_link_no_sort), http_recv_info_p->recv_uri, strlen(http_recv_info_p->recv_uri));
	strncat(current_uri_link_no_sort, "?", sizeof(current_uri_link_no_sort) - strlen(current_uri_link_no_sort)); // '?'を追加

	debug_log_output("OptionMenu: current_uri_link_no_sort='%s'", current_uri_link_no_sort);


	// -----------------------------------------
	// 現パス名 Link用(Sort情報付き) 生成
	// -----------------------------------------
 	uri_encode(current_uri_link, sizeof(current_uri_link), http_recv_info_p->recv_uri, strlen(http_recv_info_p->recv_uri));
	strncat(current_uri_link, "?", sizeof(current_uri_link) - strlen(current_uri_link)); // '?'を追加

	// sort=が指示されていた場合、それを引き継ぐ。
	if ( strlen(http_recv_info_p->sort) > 0 )
	{
		snprintf(work_data, sizeof(work_data), "sort=%s&", http_recv_info_p->sort);
		strncat(current_uri_link, work_data, sizeof(current_uri_link) - strlen(current_uri_link));
	}
	debug_log_output("OptionMenu: current_uri_link='%s'", current_uri_link);


	// ---------------------
	// 現ページ数 生成
	// ---------------------

	if ( http_recv_info_p->page <= 1 )
		now_page = 1;
	else
		now_page = http_recv_info_p->page;

	// 	現在のページ 表示用
	snprintf(now_page_str, sizeof(now_page_str), "%d", now_page );


	// ==============================
	// OptionMenu スキン読み込み
	// ==============================

	// ----------------------------------------------
	// スキンのフルパス生成
	// スキンのあるファイルパス生成
	// ----------------------------------------------
	strncpy(skin_filename, global_param.skin_root, sizeof(skin_filename) ); // スキン置き場
	if ( skin_filename[ strlen(skin_filename)-1 ] != '/' )// 最後が'/'じゃなかったら、'/'を追加
	{
		strncat(skin_filename, "/", sizeof(skin_filename) -strlen(skin_filename) );
	}

	strncat(skin_filename, global_param.skin_name, sizeof(skin_filename) - strlen(skin_filename) ); // スキン名（ディレクトリ）
	if ( skin_filename[ strlen(skin_filename)-1 ] != '/' ) // 最後が'/'じゃなかったら、'/'を追加
	{
		strncat(skin_filename, "/", sizeof(skin_filename) - strlen(skin_filename) );
	}

	// ImageView スキンファイル名生成
	strncat(skin_filename, SKIN_OPTION_MENU_HTML, sizeof(skin_filename) - strlen(skin_filename) );
	debug_log_output("skin: skin_filename='%s'", skin_filename);

	// スキンデータ読み込み
	option_menu_skin_p = skin_file_read( skin_filename, &option_menu_skin_malloc_size);


	// ==============================
	// 置換実行
	// ==============================

	// SERVER_NAME
	replase_character(option_menu_skin_p, option_menu_skin_malloc_size, SKIN_KEYWORD_SERVER_NAME, SERVER_NAME);

	//
	// CURRENT_PATH_LINK	現在のパス（LINK用 URIエンコード）
	replase_character(option_menu_skin_p, option_menu_skin_malloc_size, SKIN_KEYWORD_CURRENT_PATH_LINK, current_uri_link);

	// CURRENT_PATH_LINK	現在のパス（LINK用 URIエンコード）
	replase_character(option_menu_skin_p, option_menu_skin_malloc_size, SKIN_KEYWORD_CURRENT_PATH_LINK_NO_SORT, current_uri_link_no_sort);

	// SKIN_KEYWORD_CURRENT_PAGE	 	現在のページ
	replase_character(option_menu_skin_p, option_menu_skin_malloc_size, SKIN_KEYWORD_CURRENT_PAGE, now_page_str);



	// =================
	// 返信実行
	// =================
	http_filemenu_send( accept_socket, option_menu_skin_p );


	free(option_menu_skin_p);


	return;
}



/********************************************************************************/
// 日本語文字コード変換。
// (libnkfのラッパー関数)
//
//	サポートされている形式は以下の通り。
//		in_flag:	CODE_AUTO, CODE_SJIS, CODE_EUC, CODE_UTF8, CODE_UTF16
//		out_flag: 	CODE_SJIS, CODE_EUC
/********************************************************************************/
void convert_language_code(const unsigned char *in, unsigned char *out, size_t len, int in_flag, int out_flag)
{
	unsigned char	nkf_option[8];

	memset(nkf_option, '\0', sizeof(nkf_option));


	//=====================================================================
	// in_flag, out_flagをみて、libnkfへのオプションを組み立てる。
	//=====================================================================
	switch( in_flag )
	{
		case CODE_SJIS:
			strncpy(nkf_option, "S", sizeof(nkf_option));
			break;

		case CODE_EUC:
			strncpy(nkf_option, "E", sizeof(nkf_option));
			break;

		case CODE_UTF8:
			strncpy(nkf_option, "W", sizeof(nkf_option));
			break;

		case CODE_UTF16:
			strncpy(nkf_option, "W16", sizeof(nkf_option));
			break;

		case CODE_AUTO:
		default:
			strncpy(nkf_option, "", sizeof(nkf_option));
			break;
	}


	switch( out_flag )
	{
		case CODE_EUC:
			strncat(nkf_option, "e", sizeof(nkf_option) - strlen(nkf_option) );
			break;

		case CODE_SJIS:
		default:
			strncat(nkf_option, "s", sizeof(nkf_option) - strlen(nkf_option) );
			break;
	}


	//=================================================
	// libnkf 実行
	//=================================================
	nkf(in, out, len, nkf_option);




	return;
}

// **************************************************************************
// * MP3ファイルから、ID3v1形式のタグデータを得る
// **************************************************************************
static void  mp3_id3v1_tag_read(unsigned char *mp3_filename, SKIN_REPLASE_LINE_DATA_T *skin_rep_data_line_p )
{
	int	fd;
	unsigned char	buf[128];
	unsigned char	work_title_info[128];
	off_t		length;

	memset(buf, 			'\0', sizeof(buf));
	memset(work_title_info, '\0', sizeof(work_title_info));

	fd = open(mp3_filename,  O_RDONLY);
	if ( fd < 0 )
	{
		return;
	}

	// 最後から128byteへSEEK
	length = lseek(fd, -128, SEEK_END);


	// ------------------
	// "TAG"文字列確認
	// ------------------

	// 3byteをread. 
	read(fd, buf, 3);
	debug_log_output("buf='%s'", buf);

	// "TAG" 文字列チェック
	if ( strncmp( buf, "TAG", 3 ) != 0 )
	{
		debug_log_output("NO ID3 Tag.");

		close(fd);
		return;		// MP3 タグ無し。
	}


	// ------------------------------------------------------------
	// Tag情報read
	//
	//	文字列最後に0xFFと' 'が付いていたら削除。
	//  client文字コードに変換。
	// ------------------------------------------------------------


	// 曲名
	memset(buf, '\0', sizeof(buf));
	read(fd, buf, 30);
	cut_character_at_linetail(buf, 0xFF);
	cut_character_at_linetail(buf, ' ');
	convert_language_code( 	buf, 
							skin_rep_data_line_p->mp3_id3v1_title,  
							sizeof(skin_rep_data_line_p->mp3_id3v1_title), 
							CODE_AUTO, global_param.client_language_code);


	// アーティスト
	memset(buf, '\0', sizeof(buf));
	read(fd, buf, 30);
	cut_character_at_linetail(buf, 0xFF);
	cut_character_at_linetail(buf, ' ');
	convert_language_code( 	buf, 
							skin_rep_data_line_p->mp3_id3v1_artist,  
							sizeof(skin_rep_data_line_p->mp3_id3v1_artist), 
							CODE_AUTO, global_param.client_language_code);

	// アルバム名
	memset(buf, '\0', sizeof(buf));
	read(fd, buf, 30);
	cut_character_at_linetail(buf, 0xFF);
	cut_character_at_linetail(buf, ' ');
	convert_language_code( 	buf, 
							skin_rep_data_line_p->mp3_id3v1_album,  
							sizeof(skin_rep_data_line_p->mp3_id3v1_album), 
							CODE_AUTO, global_param.client_language_code);

	// 制作年度
	memset(buf, '\0', sizeof(buf));
	read(fd, buf, 4);
	cut_character_at_linetail(buf, 0xFF);
	cut_character_at_linetail(buf, ' ');
	convert_language_code( 	buf, 
							skin_rep_data_line_p->mp3_id3v1_year,  
							sizeof(skin_rep_data_line_p->mp3_id3v1_year), 
							CODE_AUTO, global_param.client_language_code);

	// コメント
	memset(buf, '\0', sizeof(buf));
	read(fd, buf, 28);
	cut_character_at_linetail(buf, 0xFF);
	cut_character_at_linetail(buf, ' ');
	convert_language_code( 	buf, 
							skin_rep_data_line_p->mp3_id3v1_comment,  
							sizeof(skin_rep_data_line_p->mp3_id3v1_comment), 
							CODE_AUTO, global_param.client_language_code);


	// ---------------------
	// mp3_title_info生成
	// ---------------------
	strncpy(work_title_info, skin_rep_data_line_p->mp3_id3v1_title, sizeof(work_title_info));


	if ( (strlen(skin_rep_data_line_p->mp3_id3v1_album) > 0) && (strlen(skin_rep_data_line_p->mp3_id3v1_artist) > 0) )
	{
		strncat(work_title_info, " [", 									sizeof(work_title_info) - strlen(work_title_info));
		strncat(work_title_info, skin_rep_data_line_p->mp3_id3v1_album, sizeof(work_title_info) - strlen(work_title_info));
		strncat(work_title_info, "/", 									sizeof(work_title_info) - strlen(work_title_info));
		strncat(work_title_info, skin_rep_data_line_p->mp3_id3v1_artist,sizeof(work_title_info) - strlen(work_title_info));
		strncat(work_title_info, "]", 									sizeof(work_title_info) - strlen(work_title_info));
	}
	else if ( (strlen(skin_rep_data_line_p->mp3_id3v1_album) ==0) && (strlen(skin_rep_data_line_p->mp3_id3v1_artist) > 0) )
	{
		strncat(work_title_info, " [", 									sizeof(work_title_info) - strlen(work_title_info));
		strncat(work_title_info, skin_rep_data_line_p->mp3_id3v1_artist,sizeof(work_title_info) - strlen(work_title_info));
		strncat(work_title_info, "]", 									sizeof(work_title_info) - strlen(work_title_info));
	}
	else if ( (strlen(skin_rep_data_line_p->mp3_id3v1_album) > 0) && (strlen(skin_rep_data_line_p->mp3_id3v1_artist) ==0) )
	{
		strncat(work_title_info, " [", 									sizeof(work_title_info) - strlen(work_title_info));
		strncat(work_title_info, skin_rep_data_line_p->mp3_id3v1_album, sizeof(work_title_info) - strlen(work_title_info));
		strncat(work_title_info, "]", 									sizeof(work_title_info) - strlen(work_title_info));
	}

	// mp3_title_info (制限無し)を保存。
	strncpy(skin_rep_data_line_p->mp3_id3v1_title_info, work_title_info, sizeof(skin_rep_data_line_p->mp3_id3v1_title_info) );

	// EUCに変換
	convert_language_code( 	work_title_info, 
							skin_rep_data_line_p->mp3_id3v1_title_info,  
							sizeof(skin_rep_data_line_p->mp3_id3v1_title_info), 
							CODE_AUTO, CODE_EUC);
	strncpy(work_title_info, skin_rep_data_line_p->mp3_id3v1_title_info, sizeof(work_title_info));


	// 長さ制限を超えていたらCut
	if ( strlen(work_title_info) > global_param.menu_filename_length_max )
	{
		// CUT実行
		euc_string_cut_n_length(work_title_info, global_param.menu_filename_length_max);
		debug_log_output("mp3_title_info(cut)='%s'\n", work_title_info);
	}

	// クライアント文字コードに。
	convert_language_code( 	work_title_info, 
							skin_rep_data_line_p->mp3_id3v1_title_info_limited,  
							sizeof(skin_rep_data_line_p->mp3_id3v1_title_info_limited), 
							CODE_EUC, global_param.client_language_code);


	// ---------------------
	// 存在フラグ
	// ---------------------
	skin_rep_data_line_p->mp3_id3v1_flag = 1;

	close(fd);
	return;
}


// *************************************************************************************
// playlistに渡す表示ファイル名を、問題ない形式に調整する
// *************************************************************************************
static void playlist_filename_adjustment(unsigned char *src_name, unsigned char *dist_name, int dist_size, int input_code )
{
	unsigned char	work_data[FILENAME_MAX];


	// ---------------------------------
	// ファイル名 生成 (表示用)
	// EUCに変換 → 拡張子削除 → (必要なら)半角文字を全角に変換 → MediaWizコードに変換 → SJISなら、不正文字コード0x7C('|')を含む文字を伏せ字に。
	// ---------------------------------
	convert_language_code(	src_name,
							dist_name,
							dist_size,
							input_code,
							CODE_EUC);

	if ( strchr(dist_name, '.') != NULL )
	{
		cut_after_last_character(dist_name, '.');
	}
	debug_log_output("dist_name(euc)='%s'\n", dist_name);

	if (global_param.flag_allplay_filelist_adjust == TRUE)
	{
		han2euczen(dist_name, work_data, sizeof(work_data) );
		debug_log_output("dist_name(euczen)='%s'\n", work_data);
	}
	else
	{
		strncpy(work_data, dist_name, sizeof(work_data));
	}

	convert_language_code( work_data, dist_name, dist_size, CODE_AUTO, global_param.client_language_code);
	debug_log_output("dist_name(MediaWiz Code)='%s'\n", dist_name);

	if ( global_param.client_language_code == CODE_SJIS )
	{
		sjis_code_thrust_replase(dist_name, '|');
		debug_log_output("dist_name(SJIS '|' replace)='%s'\n", dist_name);
	}


	return;
}
